    include 'mkl_vsl.f90'

    program estimation

    USE random
    USE TOOL
    USE lapack95
    USE MKL_VSL_TYPE
    USE MKL_VSL
    USE omp_lib
    IMPLICIT NONE

    !******************* GENERAL VARIABLES ****************!

    CHARACTER(100)      :: path1='/home/cshsieh/research/2012_exponential_network_formation/QE_revision/empirical/'
    CHARACTER(100)      :: path2='/data/GPA_smoke_whole_school/'
    CHARACTER(100)      :: path3='/result/GPA_smoke/dep_incentive_latent_mundlak/'
    CHARACTER(40)       :: numchr
    INTEGER, PARAMETER  :: GG=15, TT=120000, MAX=101, RR=1000, Nthreads=4, H=10, DD=3
    REAL                :: c_0(GG), c_1, c_2, c_3(GG), c_4(GG), c_5(GG), c_6, kk
    REAL                :: acc_0(GG), acc_1, acc_2, acc_3(GG), acc_4(GG), acc_4v, acc_5(GG), acc_6, acc_7, acc_8
    INTEGER             :: N(GG), NN
    INTEGER             :: brng, method_gaussian, method_uniform, me, i, j, g, t, flag, ier, k,   r, d, seedsize, seed(2), errorflag, INFO, seed_mkl, t_round
    INTEGER             :: clock_max, clock_rate, clock_start, clock_stop, p1, p2, ithread, iblock,ibegin,iend
    LOGICAL, PARAMETER  :: first=.true.
    INTEGER             ::  errcode
    REAL, ALLOCATABLE   :: C1(:,:), C2(:,:), C3(:,:), C4(:,:), W(:,:), Wt(:,:), IPIV(:)
    REAL, ALLOCATABLE   :: Yc(:), Yt(:)
    REAL, ALLOCATABLE   :: X(:,:), yr_school(:), X_bar(:), XX_bar(:,:)
    TYPE (VSL_STREAM_STATE) :: stream_gaussian, stream_uniform
    REAL, DIMENSION(MAX,MAX,GG):: age, sex, race, sport, network
    REAL, DIMENSION(MAX,18,GG):: group

    !*** hyperparameters in the prior distribution ***!
    REAL, DIMENSION(14+DD)           :: gamma_0
    REAL, DIMENSION(30+2*DD)         :: beta_0
    REAL, DIMENSION(15+DD)           :: delta_0
    REAL, DIMENSION(14+DD,14+DD)     :: G_0
    REAL, DIMENSION(30+2*DD,30+2*DD) :: B_0, B_1
    REAL, DIMENSION(15+DD,15+DD)     :: D_0, D_1, INV_D_0
    REAL, DIMENSION(3)               :: sigma_0
    REAL, DIMENSION(3,3)             :: Sig_0
    REAL                             :: eta_0, COV_XI_0(16+DD,16+DD), xi_0(16+DD), xi_1(16+DD), COV_XI_1(16+DD,16+DD), A_0
    INTEGER                          :: rho_0

    !*** posterior draws of parameters *******!

    REAL, DIMENSION(14+DD,TT)    :: gamma_T
    REAL, DIMENSION(16+DD,TT)    :: xi_T
    REAL, DIMENSION(TT)          :: lambda_cT, lambda_tT, siga_cT, siga_tT, acc_rate1, acc_rate2, acc_rate6, acc_rate7, acc_rate8
    REAL, DIMENSION(30+2*DD, TT) :: beta_cT, beta_tT
    REAL, DIMENSION(15+DD, TT)   :: delta_cT, delta_tT
    REAL, DIMENSION(GG,TT)       :: alpha_cT, alpha_tT, sige_cT, sige_tT, sige_ctT, acc_rate3, acc_rate0, acc_rate4, acc_rate5

    !********VARIABLE IN M-H FOR LATENT OTUCOME ***************!

    INTEGER                :: censor(GG), missing(GG)
    REAL, DIMENSION(MAX,GG):: Yc_latent, Yt_latent
    REAL, ALLOCATABLE      :: Y_new(:), Y_old(:), zero(:), Y_new_temp(:), Y_old_temp(:)
    REAL, ALLOCATABLE      :: cov_YL(:,:), YL(:), w12(:,:), w22(:,:), wt12(:,:), wt22(:,:), S22(:,:), S22_new(:,:), S22_old(:,:)
    REAL(kind=8)        ::  pp

    !********VARIABLE IN M-H FOR GAMMA  ***************!

    REAL ::  gamma_1(14+DD), cov_gamma_1(14+DD,14+DD), gamma_2(14+DD)
    REAL, ALLOCATABLE:: psi(:,:), psi_1(:,:), psi_2(:,:), ep(:), S(:,:)
    REAL(kind=8) ::  q_1, q_2, q_g1(GG), q_g2, pp_g

    !******  VARIABLE IN M-H FOR Z_G  *******************************!

    REAL, DIMENSION(MAX,DD,GG):: zz
    REAL, ALLOCATABLE  :: zz_1(:,:), zz_2(:,:), cov_zz(:,:), temp_zz(:)

    !********VARIABLE IN M-H FOR  LAMBDA  ***************!

    REAL :: lambda_c1, lambda_c2, lambda_t1, lambda_t2
    REAL, ALLOCATABLE :: w_old(:,:), w_new(:,:), wt_old(:,:), wt_new(:,:)
    REAL :: w1, w2, w3, w4
    REAL, ALLOCATABLE :: S1(:,:), S2(:,:), S1L(:,:), S2L(:,:),  S3(:,:), S4(:,:), S_new(:,:)
    REAL, ALLOCATABLE :: ep_1t(:), ep_2t(:), ep_1c(:), ep_2c(:)
    REAL, ALLOCATABLE :: ep_1tv(:), ep_2tv(:), ep_1cv(:), ep_2cv(:)
    REAL, ALLOCATABLE :: Vc(:,:), Vt(:,:), V1(:,:), V2(:,:)
    REAL(kind=8), ALLOCATABLE :: pp_w(:,:)
    REAL(kind=8) :: like_Y1t, like_Y2t, like_Y1c, like_Y2c, pp_l(GG), q, rand
    REAL, ALLOCATABLE:: rand1(:), rand2(:), rand3(:)
    REAL, ALLOCATABLE :: f(:), h1(:), h2(:)
    REAL, ALLOCATABLE :: Y1c(:),Y2c(:), Y1t(:),Y2t(:), Y3t(:),Y4t(:), Y3c(:),Y4c(:)
    REAL, ALLOCATABLE :: Y1cs(:),Y2cs(:), Y1ts(:),Y2ts(:), Y3ts(:),Y4ts(:), Y3cs(:),Y4cs(:)


    !*************VARIABLE IN MH FOR BETA**************!

    REAL :: beta_1t(30+2*DD), beta_1c(30+2*DD), beta_2t(30+2*DD), beta_2c(30+2*DD), cov_beta_1(30+2*DD,30+2*DD)
    REAL :: beta_temp1(30+2*DD), beta_temp1v(30+2*DD), beta_temp2(30+2*DD), beta_temp2v(30+2*DD)
    REAL(kind=8) :: pp_b(GG)

    !*************VARIABLE IN MH FOR SIGMA & ALPHA_G*********!

    REAL::  alpha_1t, alpha_1c, alpha_2t, alpha_2c
    REAL :: alpha_temp1(2), alpha_temp1v(2), alpha_temp2(2), alpha_temp2v(2)
    REAL :: XVX(15+DD,15+DD), XVY(15+DD), INV_D(15+DD,15+DD), INV_D2(15+DD,15+DD), delta_temp(15+DD)
    REAL, ALLOCATABLE :: XX(:,:), ep_v(:)
    INTEGER :: rho_1, stack

    !*************VARIABLE IN MH FOR SIGMA_TC ***************!

    REAL :: sigma_1(3), sigma_2(3), COV_sigma_1(3,3), pp_sig(GG), det_1, det_2

    !********************************************************!

    INTERFACE
    SUBROUTINE contraction(NN,ep,W,lambda,Y)
    IMPLICIT NONE
    INTEGER:: NN
    REAL , INTENT(IN)  :: lambda, ep(:),  W(:,:)
    REAL, INTENT(OUT)  :: Y(:)
    END SUBROUTINE contraction
    END INTERFACE

    seedsize=2
    seed(1)=12345
    seed(2)=54321
    CALL RANDOM_SEED
    CALL RANDOM_SEED(SIZE=seedsize)
    CALL RANDOM_SEED(PUT=seed)

    seed_mkl=12345
    brng=VSL_BRNG_MT2203
    method_uniform=VSL_RNG_METHOD_UNIFORM_STD
    method_gaussian=VSL_RNG_METHOD_GAUSSIAN_ICDF
    me=VSL_MATRIX_STORAGE_FULL


    CALL networksize(GG, MAX, path1, path2, N)
    CALL define_variable(GG, age, sex, race, network, group, N, path1, path2, MAX)

    zz=0.0
    beta_0=0.0
    delta_0=0.0
    gamma_0=0.0
    eta_0=0.1
    rho_0=2
    G_0=eye(14+DD)*100.00
    B_0=eye(30+2*DD)*100.00
    D_0=eye(15+DD)*1000.00
    CALL FINDInv(D_0,INV_D_0,15+DD,ier)
    A_0=400.00
    Sig_0=eye(3)*400.0
    sigma_0(1:2)=1.0
    sigma_0(3)=0.0
    xi_0=0.0

    gamma_T(:,1)=(/ -4.8610 ,   0.4890  ,  0.3140 ,   0.2831 ,  -0.0462 ,   0.0434 ,   0.1444  ,  0.0855 ,   0.0490  ,  1.4164 ,   0.2754 ,  -0.0247 ,  -0.0026 ,   0.4799 ,  -0.2025 ,   0.0082  ,  0.2399 /)


    lambda_tT(1)=0.060
    lambda_cT(1)=0.015
    sige_cT(:,1)=0.5
    sige_tT(:,1)=19.0
    sige_ctT(:,1)=-0.5
    siga_tT(1)=13.0;
    siga_cT(1)=5.0;
    alpha_cT(:,1)=5
    alpha_tT(:,1)=-3

    !GPA !
    beta_cT(:,1)=(/ -0.0388 ,  -0.1863 ,  -0.0109 ,  -0.0384 ,  -0.2433 ,  -0.0555 ,   0.1145 ,  -0.2972 ,   0.1536 ,  -0.1624 ,  -0.1001 ,  -0.1625 ,  -0.1347 ,  -0.0679 ,   0.0216 ,   0.0009 ,  -0.0166 ,  -0.0489, &
        & -0.1824 ,  -0.0502 ,  -0.0838 ,  -0.0602 ,  -0.0924 ,   0.0261 ,   0.0472 ,  -0.2893 ,  -0.0522 ,   0.0003 ,   0.0214 ,   0.0096 ,   0.0272 ,   0.0721 ,   0.0724 ,  -0.0170 ,  -0.0235 ,  -0.0045 /)

    !Smoke !

    beta_tT(:,1)=(/  0.2051 ,  -0.0494 ,  -0.4153 ,  -1.2797 ,  -0.0591 ,   0.1891 ,  -0.0588 ,   0.2836 ,  -0.1502 ,  -0.0775 ,   1.6348 ,   0.5669 ,   0.4512 ,   0.1472 ,  -0.0636 ,  -0.0120 ,   0.0414 ,   0.0810 ,  &
        &     0.3093 ,   0.1509 ,   0.5043 ,  -0.0351 ,   0.0762 ,   0.0131 ,  -0.0273 ,   0.0728 ,   0.1639 ,   0.0344 ,   0.0682 ,   0.0173 ,  -0.0119 ,  -0.0332 ,   0.0758 ,  -0.0027 ,   0.0168 ,  -0.0579  /)

    delta_tT(:,1)=0.0
    delta_cT(:,1)=0.0

    c_0=3e-2
    c_1=5e-7
    c_2=1e-6
    c_3=2.0
    c_4=0.10
    c_5=0.05
    c_6=1e-6

    acc_1=0.0;    acc_2=0.0
    acc_3=0.0;    acc_4=0.0
    acc_5=0.0;    acc_6=0.0
    acc_rate1=0.0;    acc_rate2=0.0
    acc_rate3=0.0;    acc_rate4=0.0
    acc_rate5=0.0;    acc_rate6=0.0


    OPEN (1000, file =  trim(adjustl(path1)) // trim(adjustl(path3)) // 'gamma.txt', status='unknown')
    OPEN (2000, file =  trim(adjustl(path1)) // trim(adjustl(path3)) // 'lambda_c.txt', status='unknown')
    OPEN (3000, file =  trim(adjustl(path1)) // trim(adjustl(path3)) // 'lambda_t.txt', status='unknown')
    OPEN (4000, file =  trim(adjustl(path1)) // trim(adjustl(path3)) // 'beta_c.txt', status='unknown')
    OPEN (5000, file =  trim(adjustl(path1)) // trim(adjustl(path3)) // 'beta_t.txt', status='unknown')
    OPEN (4500, file =  trim(adjustl(path1)) // trim(adjustl(path3)) // 'delta_c.txt', status='unknown')
    OPEN (5500, file =  trim(adjustl(path1)) // trim(adjustl(path3)) // 'delta_t.txt', status='unknown')
    OPEN (6000, file =  trim(adjustl(path1)) // trim(adjustl(path3)) // 'sige_cT.txt', status='unknown')
    OPEN (7000, file =  trim(adjustl(path1)) // trim(adjustl(path3)) // 'sige_tT.txt', status='unknown')
    OPEN (8000, file =  trim(adjustl(path1)) // trim(adjustl(path3)) // 'sige_ctT.txt', status='unknown')
    OPEN (9000, file =  trim(adjustl(path1)) // trim(adjustl(path3)) // 'alpha_c.txt', status='unknown')
    OPEN (10000, file =  trim(adjustl(path1)) // trim(adjustl(path3)) // 'alpha_t.txt', status='unknown')
    OPEN (11000,file =  trim(adjustl(path1)) // trim(adjustl(path3)) // 'siga_c.txt', status='unknown')
    OPEN (12000,file =  trim(adjustl(path1)) // trim(adjustl(path3)) // 'siga_t.txt', status='unknown')


    missing=0
    DO g=1, GG
        NN=N(g)
        Yc_latent(1:NN,g)=group(1:NN,16,g)
        DO i=1, NN
            IF (Yc_latent(i,g)==0) missing(g)=missing(g)+1
        END DO
        IF (missing(g)>0) Yc_latent(1:missing(g),g)=1.5
    END DO


    censor=0
    DO g=1, GG
        NN=N(g)
        Yt_latent(1:NN,g)=group(1:NN,17,g)
        DO i=1, NN
            IF (Yt_latent(i,g)==0) censor(g)=censor(g)+1
        END DO
        IF (censor(g)>0) Yt_latent(1:censor(g),g)=-1.5
    END DO

    print*, censor


    DO t=2, TT

        call system_clock ( clock_start, clock_rate, clock_max )

        seed_mkl=seed_mkl+1
        errcode=vslnewstream(stream_gaussian,brng,seed_mkl)
        errcode=vslnewstream(stream_uniform,brng,seed_mkl)


        !*******  M-H STEP TO UPDATE  LATENT Yt ************!

        Call OMP_SET_NUM_THREADS(Nthreads)

        !$omp parallel default(shared) private(g, NN, Y_new, Y_old, yr_school, zz_1, &
        !$omp & X, XX, W, Wt, cov_YL, YL, INFO, IPIV,w12,wt12, w22, wt22, S22, ep_1t, ep_2t, zero, &
        !$omp & h1, h2,C1,C2,C3,i, j, psi, w_old, w_new, ep_1c, Y1c, Y2c, wt_old, wt_new,  &
        !$omp & r,Y1t, Y2t, Y3t, Y4t, w1, w2, w3, w4, q, pp_w, rand,  &
        !$omp & like_Y1t, like_Y2t, pp, S1, S2,  &
        !$omp & ithread, iblock, ibegin, iend)

        ithread = OMP_GET_THREAD_NUM()
        iblock = (GG+Nthreads-1)/Nthreads
        ibegin = ithread*iblock+1
        iend = min((ithread+1)*iblock,GG)

        DO g = ibegin,iend

            NN=N(g)
            ALLOCATE(Y_new(NN));     ALLOCATE(Y_old(NN))
            ALLOCATE(X(NN,15)) ;     ALLOCATE(XX(NN,30+2*DD))
            ALLOCATE(W(NN,NN));      ALLOCATE(Wt(NN,NN))
            ALLOCATE(yr_school(NN))
            ALLOCATE(ep_1t(NN));     ALLOCATE(ep_2t(NN));
            ALLOCATE(h1(NN));        ALLOCATE(h2(NN))  ;
            ALLOCATE(C1(NN,NN));     ALLOCATE(C2(NN,NN));
            ALLOCATE(C3(NN,NN));
            ALLOCATE(psi(NN,NN))
            ALLOCATE(w_old(NN,NN));  ALLOCATE(w_new(NN,NN));
            ALLOCATE(wt_old(NN,NN)); ALLOCATE(wt_new(NN,NN));
            ALLOCATE(Y1t(NN));       ALLOCATE(Y2t(NN))  ;
            ALLOCATE(Y3t(NN));       ALLOCATE(Y4t(NN))  ;
            ALLOCATE(Y1c(NN));       ALLOCATE(Y2c(NN))  ;
            ALLOCATE(pp_w(NN,NN))
            ALLOCATE(ep_1c(NN));
            ALLOCATE(S1(NN,NN))  ;   ALLOCATE(S2(NN,NN))  ;
            ALLOCATE(IPIV(NN))
            ALLOCATE(zz_1(NN,DD))


            Y_new=Yt_latent(1:NN,g)
            Y_old=Yt_latent(1:NN,g)
            C1=age(1:NN,1:NN,g)
            C2=sex(1:NN,1:NN,g)
            C3=race(1:NN,1:NN,g)
            W=network(1:NN,1:NN,g)
            Wt=transpose(W)
            X=group(1:NN,1:15,g)
            zz_1=zz(1:NN,1:DD,g)
            XX(:,1:15)=X
            XX(:,16:30)=matmul(W,X)
            XX(:,31:30+DD)=zz_1(:,1:DD)
            XX(:,31+DD:30+2*DD)=matmul(W,zz_1(:,1:DD))
            yr_school=group(1:NN,18,g)


            IF (censor(g)>0) THEN

                !!  propose latent Y !!
                DO
                    ALLOCATE(cov_YL(censor(g),censor(g)))
                    ALLOCATE(YL(censor(g)))
                    ALLOCATE(zero(censor(g)))
                    zero=Yt_latent(1:censor(g),g)
                    cov_YL=eye(censor(g))*c_0(g)
                    CALL spotrf('U',censor(g), cov_YL,censor(g),info)
                    errcode=vsrnggaussianmv(method_gaussian,stream_gaussian,1, YL, censor(g) ,me, zero , cov_YL)
                    Y_new(1:censor(g))=YL
                    DEALLOCATE(cov_YL)
                    DEALLOCATE(YL)
                    DEALLOCATE(zero)
                    IF (maxval(Y_new(1:censor(g)))<0 ) exit ! check if the max YL is still less than zero!
                END DO


                ALLOCATE(W12(censor(g),NN-censor(g)))
                ALLOCATE(W22(NN-censor(g),NN-censor(g)))
                ALLOCATE(Wt12(censor(g),NN-censor(g)))
                ALLOCATE(Wt22(NN-censor(g),NN-censor(g)))
                ALLOCATE(S22(NN-censor(g),NN-censor(g)))

                W12=W(1:censor(g),censor(g)+1:NN)
                W22=W(censor(g)+1:NN,censor(g)+1:NN)
                S22=eye(NN-censor(g))-lambda_tT(t-1)*(W22)

                !DO i=1, NN
                !    DO j=1, NN
                !        IF (DD==1) THEN
                !            psi(i,j)=gamma_T(1,t-1)+gamma_T(2,t-1)*C1(i,j)+gamma_T(3,t-1)*C2(i,j)+gamma_T(4,t-1)*C3(i,j) &
                !                & +gamma_T(5,t-1)*yr_school(i)+gamma_T(6,t-1)*yr_school(j)-gamma_T(7,t-1)*abs(zz_1(i,1)-zz_1(j,1))
                !        ELSEIF (DD==2) THEN
                !            psi(i,j)=gamma_T(1,t-1)+gamma_T(2,t-1)*C1(i,j)+gamma_T(3,t-1)*C2(i,j)+gamma_T(4,t-1)*C3(i,j) &
                !                & +gamma_T(5,t-1)*yr_school(i)+gamma_T(6,t-1)*yr_school(j)-gamma_T(7,t-1)*abs(zz_1(i,1)-zz_1(j,1)) &
                !                & -gamma_T(8,t-1)*abs(zz_1(i,2)-zz_1(j,2))
                !        ELSEIF (DD==3) THEN
                !            psi(i,j)=gamma_T(1,t-1)+gamma_T(2,t-1)*C1(i,j)+gamma_T(3,t-1)*C2(i,j)+gamma_T(4,t-1)*C3(i,j) &
                !                & +gamma_T(5,t-1)*yr_school(i)+gamma_T(6,t-1)*yr_school(j)-gamma_T(7,t-1)*abs(zz_1(i,1)-zz_1(j,1)) &
                !                & -gamma_T(8,t-1)*abs(zz_1(i,2)-zz_1(j,2))-gamma_T(9,t-1)*abs(zz_1(i,3)-zz_1(j,3))
                !        ENDIF
                !    END DO
                !END DO

                !! Define Epsilon !!
                ep_1t(1:censor(g))=Y_new(1:censor(g))-( lambda_tT(t-1)*matmul(W12,Y_new(censor(g)+1:NN))+matmul(XX(1:censor(g),:),beta_tT(:,t-1))+alpha_tT(g,t-1))
                ep_1t(censor(g)+1:NN)=matmul(S22,Y_new(censor(g)+1:NN))-matmul(XX(censor(g)+1:NN,:),beta_tT(:,t-1))-alpha_tT(g,t-1)

                ep_2t(1:censor(g))=Y_old(1:censor(g))-( lambda_tT(t-1)*matmul(W12,Y_old(censor(g)+1:NN))+matmul(XX(1:censor(g),:),beta_tT(:,t-1))+alpha_tT(g,t-1))
                ep_2t(censor(g)+1:NN)=matmul(S22,Y_old(censor(g)+1:NN))-matmul(XX(censor(g)+1:NN,:),beta_tT(:,t-1))-alpha_tT(g,t-1)

                S1=eye(NN)-(W)*lambda_cT(t-1)
                ep_1c=matmul(S1,Yc_latent(1:NN,g))-matmul(XX,beta_cT(:,t-1))-alpha_cT(g,t-1)

                !Y2c=Yc_latent(1:NN,g)
                !W_new=W
                !W_old=W
                !Wt_new=Wt
                !Wt_old=Wt
                !DO r=1, RR
                !    DO i=1, NN
                !        DO j=1, NN
                !            IF (j /= i) THEN
                !                W_new(i,j)=1-W_new(i,j)
                !                Wt_new(j,i)=1-Wt_new(j,i)
                !                XX(i,16:30)=matmul(w_new(i,:),X)
                !                XX(i,31+DD:30+2*DD)=MATMUL(w_new(i,:),zz_1(:,1:DD))
                !                h1=ep_1t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)
                !                CALL contraction(NN,h1,w_new,wt_new,lambda_tT(t-1),Y1t)
                !
                !                S1=eye(NN)-(W_new)*lambda_cT(t-1)
                !                Y1c=ep_1c+matmul(XX,beta_cT(:,t-1))+alpha_cT(g,t-1)
                !                CALL SGESV(NN,1,S1,NN,IPIV,Y1c,NN,INFO)
                !
                !                XX(i,16:30)=matmul(w_old(i,:),X)
                !                XX(i,31+DD:30+2*DD)=matmul(w_old(i,:),zz_1(:,1:DD))
                !                h1=ep_1t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)
                !                CALL contraction(NN,h1,w_old,wt_old,lambda_tT(t-1),Y2t)
                !
                !                w1=dot_product(w_new(i,:),w_new(j,:))
                !                w2=dot_product(w_new(:,i),w_new(:,j))
                !                w3=dot_product(w_new(i,:),w_new(:,j))
                !                w4=dot_product(w_new(j,:),w_new(:,i))
                !
                !                q=psi(i,j) +2*gamma_T(7+DD,t-1)*w_new(j,i)+(2*gamma_T(8+DD,t-1)-gamma_T(9+DD,t-1))*(sum(w_new(i,:))-w_new(i,j)) &
                !                    &+3*gamma_T(9+DD,t-1)*(sum(w_new(i,:))-w_new(i,j))**2 &
                !                    &+2*gamma_T(10+DD,t-1)*(sum(w_new(:,j))-w_new(i,j)) +gamma_T(11+DD,t-1)*(w1+w2+w3)+gamma_T(12+DD,t-1)*3*w4
                !
                !                pp_w(i,j)=q*(-1)**(1-w_new(i,j))+gamma_T(13+DD,t-1)*(dot_product(Y1t,Y1t)-dot_product(Y2t,Y2t) )/2.0 &
                !                    & +gamma_T(14+DD,t-1)*(dot_product(Y1c,Y1c)-dot_product(Y2c,Y2c) )/2.0
                !
                !                CALL random_number(rand)
                !                IF (log(rand)<=pp_w(i,j)) then
                !                    W_old(i,j)=W_new(i,j)
                !                    Wt_old(j,i)=Wt_new(j,i)
                !                    Y2c=Y1c
                !                END IF
                !                W_new(i,j)=W_old(i,j)
                !                Wt_new(j,i)=Wt_old(j,i)
                !                XX(i,16:30)=matmul(w_new(i,:),X)
                !                XX(i,31+DD:30+2*DD)=matmul(w_new(i,:),zz_1(:,1:DD))
                !            END IF
                !        END DO
                !    END DO
                !END DO

                !XX(:,1:15)=X
                !XX(:,16:30)=matmul(W,X)
                !XX(:,31:30+DD)=zz_1(:,1:DD)
                !XX(:,31+DD:30+2*DD)=matmul(W,zz_1(:,1:DD))
                !h1=ep_1t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)
                !h2=ep_2t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)
                !
                !CALL contraction(NN,h1,W,Wt,lambda_tT(t-1),Y1t)
                !CALL contraction(NN,h2,W,Wt,lambda_tT(t-1),Y2t)
                !
                !XX(:,16:30)=matmul(w_new,X)
                !XX(:,31+DD:30+2*DD)=matmul(w_new,zz_1(:,1:DD))
                !h1=ep_1t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)
                !h2=ep_2t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)
                !
                !CALL contraction(NN,h2,W_new,Wt_new,lambda_tT(t-1),Y3t)
                !CALL contraction(NN,h1,W_new,Wt_new,lambda_tT(t-1),Y4t)

                ep_1t=ep_1t-sige_ctT(g,t-1)/sige_cT(g,t-1)*ep_1c
                ep_2t=ep_2t-sige_ctT(g,t-1)/sige_cT(g,t-1)*ep_1c

                like_Y1t=-1*dot_product(ep_1t, ep_1t)/(2*(sige_tT(g,t-1)-sige_ctT(g,t-1)/sige_cT(g,t-1)*sige_ctT(g,t-1)))
                like_Y2t=-1*dot_product(ep_2t, ep_2t)/(2*(sige_tT(g,t-1)-sige_ctT(g,t-1)/sige_cT(g,t-1)*sige_ctT(g,t-1)))

                pp=(like_Y1t-like_Y2t)+logmvnpdf(Y_new(1:censor(g)),eye(censor(g)),censor(g))-logmvnpdf(Y_old(1:censor(g)),eye(censor(g)),censor(g))
                !   & +gamma_T(13+DD,t-1)*(dot_product(Y1t,Y1t)-dot_product(Y2t,Y2t)+dot_product(Y3t,Y3t)-dot_product(Y4t,Y4t))/2.0

                CALL random_number(rand)
                IF (log(rand)<=pp) then
                    Yt_latent(1:NN,g) = Y_new(1:NN)
                    acc_0(g)=acc_0(g)+1
                ELSE
                    Yt_latent(1:NN,g) = Y_old(1:NN)
                END IF
                acc_rate0(g,t)=acc_0(g)/t
                IF((acc_rate0(g,t)<=0.4) .and. (c_0(g)>=1e-6)) c_0(g)=c_0(g)/1.01
                IF((acc_rate0(g,t)>=0.6) .and. (c_0(g)<=2.0)) c_0(g)=c_0(g)*1.01
                DEALLOCATE(w12,wt12,w22,wt22,s22)

            END IF
            DEALLOCATE(Y_new,Y_old,X,XX,W,Wt,yr_school,ep_1t,ep_2t,h1,h2,C1,C2,C3,psi,w_old,w_new,wt_old,wt_new,Y1t,Y2t,Y3t,Y4t,Y1c,Y2c,pp_w,ep_1c,S1,S2,IPIV,zz_1)
        END DO
        !$omp end parallel



        !*******  MH STEP TO UPDATE GAMMA & LAMBDA ************!

        DO
            cov_gamma_1=eye(14+DD)*c_1
            call spotrf('U',14+DD, cov_gamma_1,14+DD,info)
            errcode=vsrnggaussianmv(method_gaussian,stream_gaussian,1,gamma_1,14+DD,me,gamma_0, cov_gamma_1)
            gamma_1=gamma_1+gamma_T(:,t-1)
            lambda_t1=lambda_tT(t-1)+random_normal()*sqrt(c_1)
            lambda_c1=lambda_cT(t-1)+random_normal()*sqrt(c_1)

            IF (t>1000) THEN

                cov_gamma_1=cov(gamma_T(:,1:t-1),14+DD,t-1)*2.38**2/(14+DD)
                call spotrf('U',14+DD, cov_gamma_1, 14+DD, info)
                errcode=vsrnggaussianmv(method_gaussian,stream_gaussian,1,gamma_2, 14+DD, me, gamma_0, cov_gamma_1)
                gamma_2=gamma_2+gamma_T(:,t-1)
                gamma_1=0.8*gamma_2+0.2*gamma_1

                lambda_t2=random_normal()*sqrt(var(lambda_tT(1:t-1),t-1))*2.38+lambda_tT(t-1)
                lambda_t1=0.8*lambda_t2+0.2*lambda_t1

                lambda_c2=random_normal()*sqrt(var(lambda_cT(1:t-1),t-1))*2.38+lambda_cT(t-1)
                lambda_c1=0.8*lambda_c2+0.2*lambda_c1

            END IF

            gamma_2=gamma_T(:,t-1)

            IF ((gamma_1(13+DD)>=0.0) .and. (gamma_1(13+DD)<=0.05) .and. (gamma_1(14+DD)>=0.0) .and. (gamma_1(14+DD)<=0.40) &
                & .and. (lambda_t1>0.0) .and. (lambda_t1>lambda_c1) .and. (lambda_c1>0.0) .and. (lambda_c1<=0.05))  EXIT !.and. (gamma_1(13+DD)<=0.005)
        END DO

        pp_l=0.0
        q_g1=0.0
        Call OMP_SET_NUM_THREADS(Nthreads)

        !$omp parallel default(shared) private(g,NN,C1,C2,C3,W,Wt,Yc,Yt,X,XX,yr_school, &
        !$omp & ep_1t,ep_2t, ep_1c,ep_2c, h1,h2, i, j, psi, w12,wt12, w22,wt22, S22, S22_new, S22_old,  &
        !$omp & IPIV,INFO, S1,S2, S3, S4, w_old,w_new,r,w1,w2,w3,w4,Y1t,Y2t,Y1c,Y2c, pp_w, k, kk, pp, acc_4v, &
        !$omp & q,rand,psi_1,psi_2, Y3t,Y4t, Y3c, Y4c, wt_new, wt_old, zz_1, zz_2, cov_zz, temp_zz, zero, d,  &
        !$omp & errcode, rand1, rand2, rand3, &
        !$omp & Y1ts,Y2ts,Y1cs,Y2cs, Y3ts,Y4ts,Y3cs,Y4cs,like_Y1t,like_Y2t, like_Y1c,like_Y2c, q_1, ithread, iblock, ibegin, iend)

        ithread = OMP_GET_THREAD_NUM()
        iblock = (GG+Nthreads-1)/Nthreads
        ibegin = ithread*iblock+1
        iend = min((ithread+1)*iblock,GG)

        DO g = ibegin,iend
            NN=N(g)
            ALLOCATE(yr_school(NN));
            ALLOCATE(C1(NN,NN));   ALLOCATE(C2(NN,NN));  ALLOCATE(C3(NN,NN))
            ALLOCATE(W(NN,NN));    ALLOCATE(Wt(NN,NN));
            ALLOCATE(Yc(NN));      ALLOCATE(Yt(NN));
            ALLOCATE(X(NN,15));    ALLOCATE(XX(NN,30+2*DD));
            ALLOCATE(ep_1t(NN));   ALLOCATE(ep_2t(NN));
            ALLOCATE(ep_1c(NN));   ALLOCATE(ep_2c(NN));
            ALLOCATE(Y1t(NN));     ALLOCATE(Y2t(NN));
            ALLOCATE(Y1c(NN));     ALLOCATE(Y2c(NN));
            ALLOCATE(Y1ts(NN));    ALLOCATE(Y2ts(NN));
            ALLOCATE(Y1cs(NN));    ALLOCATE(Y2cs(NN));
            ALLOCATE(Y3t(NN));     ALLOCATE(Y4t(NN));
            ALLOCATE(Y3c(NN));     ALLOCATE(Y4c(NN));
            ALLOCATE(Y3ts(NN));    ALLOCATE(Y4ts(NN));
            ALLOCATE(Y3cs(NN));    ALLOCATE(Y4cs(NN));
            ALLOCATE(h1(NN));      ALLOCATE(h2(NN));
            ALLOCATE(psi(NN,NN));
            ALLOCATE(S1(NN,NN));   ALLOCATE(S2(NN,NN));
            ALLOCATE(S3(NN,NN));   ALLOCATE(S4(NN,NN));
            ALLOCATE(IPIV(NN))
            ALLOCATE(w_old(NN,NN));ALLOCATE(w_new(NN,NN));
            ALLOCATE(wt_old(NN,NN));ALLOCATE(wt_new(NN,NN));
            ALLOCATE(pp_w(NN,NN))
            ALLOCATE(psi_1(NN,NN));ALLOCATE(psi_2(NN,NN));
            ALLOCATE(zz_1(NN,DD)); ALLOCATE(zz_2(NN,DD))
            ALLOCATE(rand1(RR));   ALLOCATE(rand2(RR))
            ALLOCATE(rand3(RR));

            C1=age(1:NN,1:NN,g)
            C2=sex(1:NN,1:NN,g)
            C3=race(1:NN,1:NN,g)
            W=network(1:NN,1:NN,g)
            Wt=transpose(W)
            Yt=Yt_latent(1:NN,g)
            Yc=Yc_latent(1:NN,g)
            zz_1=zz(1:NN,1:DD,g)
            zz_2=zz(1:NN,1:DD,g)
            X=group(1:NN,1:15,g)
            XX(:,1:15)=X
            XX(:,16:30)=matmul(W,X)
            yr_school=group(1:NN,18,g)

            psi=0.0
            DO i=1, NN
                DO j=1, NN
                    IF (j/=i) THEN
                        psi(i,j)=gamma_T(1,t-1)+gamma_T(2,t-1)*C1(i,j)+gamma_T(3,t-1)*C2(i,j)+gamma_T(4,t-1)*C3(i,j) &
                            & +gamma_T(5,t-1)*yr_school(i)+gamma_T(6,t-1)*yr_school(j)
                    ENDIF
                END DO
            END DO

            ALLOCATE(w12(censor(g),NN-censor(g)))
            ALLOCATE(w22(NN-censor(g),NN-censor(g)))
            ALLOCATE(wt12(censor(g),NN-censor(g)))
            ALLOCATE(wt22(NN-censor(g),NN-censor(g)))
            ALLOCATE(S22(NN-censor(g),NN-censor(g)))

            w12=W(1:censor(g),censor(g)+1:NN)
            w22=W(censor(g)+1:NN,censor(g)+1:NN)
            wt12=Wt(1:censor(g),censor(g)+1:NN)
            wt22=Wt(censor(g)+1:NN,censor(g)+1:NN)
            S22=eye(NN-censor(g))-lambda_tT(t-1)*(W22)

            ! THE DMH ALGORITHM FOR SAMPLING Z !

            kk=NN
            kk=floor(kk/H)
            IF (kk==0) kk=kk+1

            acc_4v=0.0
            DO k=1, kk
                IF(k==kk) THEN
                    ALLOCATE(cov_zz(NN-(k-1)*H,NN-(k-1)*H))
                    ALLOCATE(temp_zz(NN-(k-1)*H))
                    ALLOCATE(zero(NN-(k-1)*H))
                    zero=0.0
                    cov_zz=EYE(NN-(k-1)*H)*c_4(g)
                    call spotrf('U',NN-(k-1)*H, cov_zz, NN-(k-1)*H, info)
                    DO d=1, DD
                        errcode=vsrnggaussianmv(method_gaussian,stream_gaussian, 1, temp_zz, NN-(k-1)*H, me, zero, cov_zz)
                        zz_1((k-1)*H+1:NN,d)=temp_zz+zz_2((k-1)*H+1:NN,d)
                    END DO
                    DEALLOCATE(cov_zz,temp_zz,zero)
                ELSE
                    ALLOCATE(cov_zz(H,H))
                    ALLOCATE(temp_zz(H))
                    ALLOCATE(zero(H))
                    zero=0.0
                    cov_zz=EYE(H)*c_4(g)
                    call spotrf('U',H, cov_zz, H, info)
                    DO d=1,DD
                        errcode=vsrnggaussianmv(method_gaussian,stream_gaussian, 1, temp_zz, H, me, zero, cov_zz)
                        zz_1((k-1)*H+1:k*H,d)=temp_zz+zz_2((k-1)*H+1:k*H,d)
                    END DO
                    DEALLOCATE(cov_zz,temp_zz,zero)
                END IF

                !! Define Epsilon !!

                S1=eye(NN)-(W)*lambda_cT(t-1)

                XX(:,31:30+DD)=zz_1(:,1:DD)
                XX(:,31+DD:30+2*DD)=matmul(W,zz_1(:,1:DD))

                ep_1t(1:censor(g))=Yt(1:censor(g))-(lambda_tT(t-1)*matmul(W12,Yt(censor(g)+1:NN))+matmul(XX(1:censor(g),:),beta_tT(:,t-1))+alpha_tT(g,t-1))
                ep_1t(censor(g)+1:NN)=matmul(S22,Yt(censor(g)+1:NN))-matmul(XX(censor(g)+1:NN,:),beta_tT(:,t-1))-alpha_tT(g,t-1)
                ep_1c=matmul(S1,Yc)-matmul(XX,beta_cT(:,t-1))-alpha_cT(g,t-1)

                XX(:,31:30+DD)=zz_2(:,1:DD)
                XX(:,31+DD:30+2*DD)=matmul(W,zz_2(:,1:DD))

                ep_2t(1:censor(g))=Yt(1:censor(g))-(lambda_tT(t-1)*matmul(W12,Yt(censor(g)+1:NN))+matmul(XX(1:censor(g),:),beta_tT(:,t-1))+alpha_tT(g,t-1))
                ep_2t(censor(g)+1:NN)=matmul(S22,Yt(censor(g)+1:NN))-matmul(XX(censor(g)+1:NN,:),beta_tT(:,t-1))-alpha_tT(g,t-1)
                ep_2c=matmul(S1,Yc)-matmul(XX,beta_cT(:,t-1))-alpha_cT(g,t-1)


                Y2c=Yc_latent(1:NN,g)
                W_new=W
                W_old=W

                errcode=vsrnguniform( method_uniform, stream_uniform, RR, rand1, 0.0, 1.0)
                errcode=vsrnguniform( method_uniform, stream_uniform, RR, rand2, 0.0, 1.0)
                errcode=vsrnguniform( method_uniform, stream_uniform, RR, rand3, 0.0, 1.0)

                rand1=FLOOR(rand1*NN)
                rand2=FLOOR(rand2*NN)
                rand3=log(rand3)


                DO r=1, RR
                    i=rand1(r)
                    j=rand2(r)
                    !DO i=1, NN
                    !    DO j=1, NN
                    IF ((i>=1) .and. (i<=NN) .and. (j>=1) .and. (j<=NN) .and. (j /= i)) THEN
                        w_new(i,j)=1-w_new(i,j)

                        XX(i,16:30)=matmul(w_new(i,:),X)
                        XX(i,31+DD:30+2*DD)=matmul(w_new(i,:),zz_1(:,1:DD))
                        h1=ep_1t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)
                        CALL contraction(NN,h1,w_new,lambda_tT(t-1),Y1t)

                        S1=eye(NN)-(W_new)*lambda_cT(t-1)
                        Y1c=ep_1c+matmul(XX,beta_cT(:,t-1))+alpha_cT(g,t-1)
                        CALL SGESV(NN,1,S1,NN,IPIV,Y1c,NN,INFO)

                        XX(i,16:30)=matmul(w_old(i,:),X)
                        XX(i,31+DD:30+2*DD)=matmul(w_old(i,:),zz_1(:,1:DD))
                        h1=ep_1t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)
                        CALL contraction(NN,h1,w_old,lambda_tT(t-1),Y2t)

                        w1=dot_product(w_new(i,:),w_new(j,:))
                        w2=dot_product(w_new(:,i),w_new(:,j))
                        w3=dot_product(w_new(i,:),w_new(:,j))
                        w4=dot_product(w_new(j,:),w_new(:,i))

                        q=psi(i,j)-gamma_T(7,t-1)*abs(zz_1(i,1)-zz_1(j,1))-gamma_T(8,t-1)*abs(zz_1(i,2)-zz_1(j,2))-gamma_T(9,t-1)*abs(zz_1(i,3)-zz_1(j,3))

                        q=q+2*gamma_T(7+DD,t-1)*w_new(j,i)+(2*gamma_T(8+DD,t-1)-gamma_T(9+DD,t-1))*(sum(w_new(i,:))-w_new(i,j)) &
                            &+3*gamma_T(9+DD,t-1)*(sum(w_new(i,:))-w_new(i,j))**2 &
                            &+2*gamma_T(10+DD,t-1)*(sum(w_new(:,j))-w_new(i,j))+gamma_T(11+DD,t-1)*(w1+w2+w3)+gamma_T(12+DD,t-1)*3*w4


                        pp_w(i,j)=q*(-1)**(1-w_new(i,j))+0.5*gamma_T(13+DD,t-1)*(dot_product(Y1t,Y1t)-dot_product(Y2t,Y2t)) &
                            & + 0.5*gamma_T(14+DD,t-1)*(dot_product(Y1c,Y1c)-dot_product(Y2c,Y2c))

                        !CALL random_number(rand)
                        IF (rand3(r)<=pp_w(i,j)) then
                            W_old(i,j)=W_new(i,j)
                            Y2c=Y1c
                        END IF
                        W_new(i,j)=W_old(i,j)
                        XX(i,16:30)=matmul(w_new(i,:),X)
                        XX(i,31+DD:30+2*DD)=matmul(w_new(i,:),zz_1(:,1:DD))
                    END IF
                    !    END DO
                    !END DO
                END DO

                psi_1=0.0
                psi_2=0.0
                DO i=1,NN
                    DO j=1,NN
                        IF (j/=i) THEN
                            IF (DD==1) THEN
                                psi_1(i,j)=psi(i,j)-gamma_T(7,t-1)*abs(zz_1(i,1)-zz_1(j,1))
                                psi_2(i,j)=psi(i,j)-gamma_T(7,t-1)*abs(zz_2(i,1)-zz_2(j,1))
                            ELSEIF (DD==2) THEN
                                psi_1(i,j)=psi(i,j)-gamma_T(7,t-1)*abs(zz_1(i,1)-zz_1(j,1))-gamma_T(8,t-1)*abs(zz_1(i,2)-zz_1(j,2))
                                psi_2(i,j)=psi(i,j)-gamma_T(7,t-1)*abs(zz_2(i,1)-zz_2(j,1))-gamma_T(8,t-1)*abs(zz_2(i,2)-zz_2(j,2))
                            ELSEIF (DD==3) THEN
                                psi_1(i,j)=psi(i,j)-gamma_T(7,t-1)*abs(zz_1(i,1)-zz_1(j,1))-gamma_T(8,t-1)*abs(zz_1(i,2)-zz_1(j,2))-gamma_T(9,t-1)*abs(zz_1(i,3)-zz_1(j,3))
                                psi_2(i,j)=psi(i,j)-gamma_T(7,t-1)*abs(zz_2(i,1)-zz_2(j,1))-gamma_T(8,t-1)*abs(zz_2(i,2)-zz_2(j,2))-gamma_T(9,t-1)*abs(zz_2(i,3)-zz_2(j,3))
                            END IF
                        ENDIF
                    END DO
                END DO

                like_Y1c=-dot_product(ep_1c, ep_1c)/(2*sige_cT(g,t-1))
                like_Y2c=-dot_product(ep_2c, ep_2c)/(2*sige_cT(g,t-1))

                XX(:,1:15)=X
                XX(:,16:30)=matmul(W_new,X)
                XX(:,31:30+DD)=zz_2(:,1:DD)
                XX(:,31+DD:30+2*DD)=matmul(W_new,zz_2(:,1:DD))
                Y3c=matmul(XX,beta_cT(:,t-1))+alpha_cT(g,t-1)+ep_2c
                XX(:,31:30+DD)=zz_1(:,1:DD)
                XX(:,31+DD:30+2*DD)=matmul(W_new,zz_1(:,1:DD))
                Y4c=matmul(XX,beta_cT(:,t-1))+alpha_cT(g,t-1)+ep_1c
                S3=eye(NN)-lambda_cT(t-1)*(W_new)
                S4=eye(NN)-lambda_cT(t-1)*(W_new)
                CALL SGESV(NN,1,S3,NN,IPIV,Y3c,NN,INFO)
                CALL SGESV(NN,1,S4,NN,IPIV,Y4c,NN,INFO)

                ep_1t=ep_1t-sige_ctT(g,t-1)/sige_cT(g,t-1)*ep_1c
                ep_2t=ep_2t-sige_ctT(g,t-1)/sige_cT(g,t-1)*ep_2c

                like_Y1t=-dot_product(ep_1t, ep_1t)/(2*(sige_tT(g,t-1)-sige_ctT(g,t-1)/sige_cT(g,t-1)*sige_ctT(g,t-1)))
                like_Y2t=-dot_product(ep_2t, ep_2t)/(2*(sige_tT(g,t-1)-sige_ctT(g,t-1)/sige_cT(g,t-1)*sige_ctT(g,t-1)))

                XX(:,1:15)=X
                XX(:,16:30)=matmul(W,X)
                XX(:,31:30+DD)=zz_1(:,1:DD)
                XX(:,31+DD:30+2*DD)=matmul(W,zz_1(:,1:DD))
                h1=ep_1t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)
                XX(:,31:30+DD)=zz_2(:,1:DD)
                XX(:,31+DD:30+2*DD)=matmul(W,zz_2(:,1:DD))
                h2=ep_2t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)

                CALL contraction(NN,h1,W,lambda_tT(t-1),Y1t)
                CALL contraction(NN,h2,W,lambda_tT(t-1),Y2t)

                XX(:,1:15)=X
                XX(:,16:30)=matmul(W_new,X)
                XX(:,31:30+DD)=zz_1(:,1:DD)
                XX(:,31+DD:30+2*DD)=matmul(w_new,zz_1(:,1:DD))
                h1=ep_1t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)
                XX(:,31:30+DD)=zz_2(:,1:DD)
                XX(:,31+DD:30+2*DD)=matmul(w_new,zz_2(:,1:DD))
                h2=ep_2t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)

                CALL contraction(NN,h2,w_new,lambda_tT(t-1),Y3t)
                CALL contraction(NN,h1,w_new,lambda_tT(t-1),Y4t)

                pp= trace(matmul(psi_1,transpose(W)),NN)- trace(matmul(psi_2,transpose(W)),NN) &
                    &+trace(matmul(psi_2,transpose(w_new)),NN)-trace(matmul(psi_1,transpose(w_new)),NN) &
                    &+0.5*gamma_T(13+DD,t-1)*(dot_product(Y1t,Y1t)+dot_product(Y3t,Y3t)-dot_product(Y2t,Y2t)-dot_product(Y4t,Y4t)) &
                    &+0.5*gamma_T(14+DD,t-1)*(dot_product(Y3c,Y3c)-dot_product(Y4c,Y4c))


                IF (k==kk) THEN
                    pp=pp+(like_Y1t-like_Y2t)+(like_Y1c-like_Y2c)+logmvnpdf(reshape(zz_1((k-1)*H+1:NN,:),(/(NN-(k-1)*H)*DD,1/)),eye((NN-(k-1)*H)*DD),(NN-(k-1)*H)*DD)-logmvnpdf(reshape(zz_2((k-1)*H+1:NN,:),(/(NN-(k-1)*H)*DD,1/)),eye((NN-(k-1)*H)*DD),(NN-(k-1)*H)*DD)
                ELSE
                    pp=pp+(like_Y1t-like_Y2t)+(like_Y1c-like_Y2c)+logmvnpdf(reshape(zz_1((k-1)*H+1:k*H,:),(/H*DD,1/)),eye(H*DD),H*DD)-logmvnpdf(reshape(zz_2((k-1)*H+1:k*H,:),(/H*DD,1/)),eye(H*DD),H*DD)
                END IF

                CALL random_number(rand)
                IF (log(rand)<=pp) THEN
                    zz_2=zz_1
                    acc_4v=acc_4v+1
                END IF
                zz_1=zz_2
            END DO
            if (3*acc_4v>=kk) acc_4(g)=acc_4(g)+1
            acc_rate4(g,t)=acc_4(g)/t
            if (acc_rate4(g,t)<0.2)  c_4(g)=c_4(g)/1.01
            if (acc_rate4(g,t)>0.3)  c_4(g)=c_4(g)*1.01
            zz(1:NN,1:DD,g)=zz_1


            !*************************************!
            ! DMH step to update lambda and gamma !
            !*************************************!

            XX(:,1:15)=X
            XX(:,16:30)=matmul(W,X)
            XX(:,31:30+DD)=zz_1(:,1:DD)
            XX(:,31+DD:30+2*DD)=matmul(W,zz_1(:,1:DD))

            psi=0.0
            DO i=1, NN
                DO j=1, NN
                    IF (j/=i) THEN
                        IF (DD==1) THEN
                            psi(i,j)=gamma_1(1)+gamma_1(2)*C1(i,j)+gamma_1(3)*C2(i,j)+gamma_1(4)*C3(i,j) &
                                & +gamma_1(5)*yr_school(i)+gamma_1(6)*yr_school(j)-gamma_1(7)*abs(zz_1(i,1)-zz_1(j,1))
                        ELSEIF (DD==2) THEN
                            psi(i,j)=gamma_1(1)+gamma_1(2)*C1(i,j)+gamma_1(3)*C2(i,j)+gamma_1(4)*C3(i,j) &
                                & +gamma_1(5)*yr_school(i)+gamma_1(6)*yr_school(j)-gamma_1(7)*abs(zz_1(i,1)-zz_1(j,1)) &
                                & -gamma_1(8)*abs(zz_1(i,2)-zz_1(j,2))
                        ELSEIF (DD==3) THEN
                            psi(i,j)=gamma_1(1)+gamma_1(2)*C1(i,j)+gamma_1(3)*C2(i,j)+gamma_1(4)*C3(i,j) &
                                & +gamma_1(5)*yr_school(i)+gamma_1(6)*yr_school(j)-gamma_1(7)*abs(zz_1(i,1)-zz_1(j,1)) &
                                & -gamma_1(8)*abs(zz_1(i,2)-zz_1(j,2))-gamma_1(9)*abs(zz_1(i,3)-zz_1(j,3))
                        ENDIF
                    ENDIF
                END DO
            END DO

            ALLOCATE(S22_new(NN-censor(g),NN-censor(g)))
            ALLOCATE(S22_old(NN-censor(g),NN-censor(g)))

            S22_new=eye(NN-censor(g))-lambda_t1*(W22)
            S22_old=eye(NN-censor(g))-lambda_tT(t-1)*(W22)

            !! Define Epsilon !!
            ep_1t(1:censor(g))=Yt(1:censor(g))-( lambda_t1     *matmul(W12,Yt(censor(g)+1:NN))+matmul(XX(1:censor(g),:),beta_tT(:,t-1))+alpha_tT(g,t-1))
            ep_1t(censor(g)+1:NN)=matmul(S22_new,Yt(censor(g)+1:NN))-matmul(XX(censor(g)+1:NN,:),beta_tT(:,t-1))-alpha_tT(g,t-1)

            ep_2t(1:censor(g))=Yt(1:censor(g))-( lambda_tT(t-1)*matmul(W12,Yt(censor(g)+1:NN))+matmul(XX(1:censor(g),:),beta_tT(:,t-1))+alpha_tT(g,t-1))
            ep_2t(censor(g)+1:NN)=matmul(S22_old,Yt(censor(g)+1:NN))-matmul(XX(censor(g)+1:NN,:),beta_tT(:,t-1))-alpha_tT(g,t-1)

            S1=eye(NN)-(W)*lambda_c1
            S2=eye(NN)-(W)*lambda_cT(t-1)

            ep_1c=matmul(S1,Yc)-matmul(XX,beta_cT(:,t-1))-alpha_cT(g,t-1)
            ep_2c=matmul(S2,Yc)-matmul(XX,beta_cT(:,t-1))-alpha_cT(g,t-1)


            Y2c=Yc_latent(1:NN,g)
            W_new=W
            W_old=W

            errcode=vsrnguniform( method_uniform, stream_uniform, RR, rand1, 0.0, 1.0)
            errcode=vsrnguniform( method_uniform, stream_uniform, RR, rand2, 0.0, 1.0)
            errcode=vsrnguniform( method_uniform, stream_uniform, RR, rand3, 0.0, 1.0)

            rand1=FLOOR(rand1*NN)
            rand2=FLOOR(rand2*NN)
            rand3=log(rand3)

            DO r=1, RR
                i=rand1(r)
                j=rand2(r)
                !DO i=1, NN
                !    DO j=1, NN
                IF ((i>=1) .and. (i<=NN) .and. (j>=1) .and. (j<=NN) .and. (j /= i)) THEN
                    w_new(i,j)=1-w_new(i,j)
                    XX(i,16:30)=matmul(w_new(i,:),X)
                    XX(i,31+DD:30+2*DD)=matmul(w_new(i,:),zz_1(:,1:DD))
                    h1=ep_1t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)
                    CALL contraction(NN,h1,w_new,lambda_t1,Y1t)

                    S1=eye(NN)-(W_new)*lambda_c1
                    Y1c=ep_1c+matmul(XX,beta_cT(:,t-1))+alpha_cT(g,t-1)
                    CALL SGESV(NN,1,S1,NN,IPIV,Y1c,NN,INFO)

                    XX(i,16:30)=matmul(w_old(i,:),X)
                    XX(i,31+DD:30+2*DD)=matmul(w_old(i,:),zz_1(:,1:DD))
                    h1=ep_1t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)
                    CALL contraction(NN,h1,w_old,lambda_t1,Y2t)


                    w1=dot_product(w_new(i,:),w_new(j,:))
                    w2=dot_product(w_new(:,i),w_new(:,j))
                    w3=dot_product(w_new(i,:),w_new(:,j))
                    w4=dot_product(w_new(j,:),w_new(:,i))

                    q=psi(i,j)+2*gamma_1(7+DD)*w_new(j,i)+(2*gamma_1(8+DD)-gamma_1(9+DD))*(sum(w_new(i,:))-w_new(i,j)) &
                        &+3*gamma_1(9+DD)*(sum(w_new(i,:))-w_new(i,j))**2 &
                        &+2*gamma_1(10+DD)*(sum(w_new(:,j))-w_new(i,j))+gamma_1(11+DD)*(w1+w2+w3)+gamma_1(12+DD)*3*w4

                    pp_w(i,j)=q*(-1)**(1-w_new(i,j))+0.5*gamma_1(13+DD)*(dot_product(Y1t,Y1t)-dot_product(Y2t,Y2t)) &
                        & + 0.5*gamma_1(14+DD)*(dot_product(Y1c,Y1c)-dot_product(Y2c,Y2c))

                    !CALL random_number(rand)
                    IF (rand3(r)<=pp_w(i,j)) then
                        W_old(i,j)=W_new(i,j)
                        Y2c=Y1c
                    END IF
                    W_new(i,j)=W_old(i,j)
                    XX(i,16:30)=matmul(w_new(i,:),X)
                    XX(i,31+DD:30+2*DD)=MATMUL(w_new(i,:),zz_1(:,1:DD))
                END IF
                !    END DO
                !END DO
            END DO

            psi_1=0.0
            psi_2=0.0
            DO i=1, NN
                DO j=1, NN
                    IF (j/=i) THEN
                        IF (DD==1) THEN
                            psi_1(i,j)=gamma_1(1)+gamma_1(2)*c1(i,j)+gamma_1(3)*c2(i,j)+gamma_1(4)*c3(i,j) &
                                &   +gamma_1(5)*yr_school(i)+gamma_1(6)*yr_school(j)-gamma_1(7)*abs(zz_1(i,1)-zz_1(j,1))
                            psi_2(i,j)=gamma_2(1)+gamma_2(2)*c1(i,j)+gamma_2(3)*c2(i,j)+gamma_2(4)*c3(i,j) &
                                &   +gamma_2(5)*yr_school(i)+gamma_2(6)*yr_school(j)-gamma_2(7)*abs(zz_1(i,1)-zz_1(j,1))
                        ELSEIF (DD==2) THEN
                            psi_1(i,j)=gamma_1(1)+gamma_1(2)*c1(i,j)+gamma_1(3)*c2(i,j)+gamma_1(4)*c3(i,j) &
                                &   +gamma_1(5)*yr_school(i)+gamma_1(6)*yr_school(j)-gamma_1(7)*abs(zz_1(i,1)-zz_1(j,1))-gamma_1(8)*abs(zz_1(i,2)-zz_1(j,2))
                            psi_2(i,j)=gamma_2(1)+gamma_2(2)*c1(i,j)+gamma_2(3)*c2(i,j)+gamma_2(4)*c3(i,j) &
                                &   +gamma_2(5)*yr_school(i)+gamma_2(6)*yr_school(j)-gamma_2(7)*abs(zz_1(i,1)-zz_1(j,1))-gamma_2(8)*abs(zz_1(i,2)-zz_1(j,2))
                        ELSEIF (DD==3) THEN
                            psi_1(i,j)=gamma_1(1)+gamma_1(2)*c1(i,j)+gamma_1(3)*c2(i,j)+gamma_1(4)*c3(i,j) &
                                &   +gamma_1(5)*yr_school(i)+gamma_1(6)*yr_school(j)-gamma_1(7)*abs(zz_1(i,1)-zz_1(j,1))-gamma_1(8)*abs(zz_1(i,2)-zz_1(j,2))-gamma_1(9)*abs(zz_1(i,3)-zz_1(j,3))
                            psi_2(i,j)=gamma_2(1)+gamma_2(2)*c1(i,j)+gamma_2(3)*c2(i,j)+gamma_2(4)*c3(i,j) &
                                &   +gamma_2(5)*yr_school(i)+gamma_2(6)*yr_school(j)-gamma_2(7)*abs(zz_1(i,1)-zz_1(j,1))-gamma_2(8)*abs(zz_1(i,2)-zz_1(j,2))-gamma_2(9)*abs(zz_1(i,3)-zz_1(j,3))
                        ENDIF
                    ENDIF
                END DO
            END DO

            XX(:,1:15)=X
            XX(:,16:30)=matmul(W,X)
            XX(:,31:30+DD)=zz_1(:,1:DD)
            XX(:,31+DD:30+2*DD)=matmul(W,zz_1(:,1:DD))

            h1=ep_1t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)
            h2=ep_2t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)

            CALL contraction(NN,h1,W,lambda_t1,Y1t)
            CALL contraction(NN,h2,W,lambda_tT(t-1),Y2t)

            XX(:,16:30)=matmul(w_new,X)
            XX(:,31+DD:30+2*DD)=matmul(w_new,zz_1(:,1:DD))
            h1=ep_1t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)
            h2=ep_2t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)

            CALL contraction(NN,h2,w_new,lambda_tT(t-1),Y3t)
            CALL contraction(NN,h1,w_new,lambda_t1,Y4t)

            S1=eye(NN)-(W)*lambda_c1
            S2=eye(NN)-(W)*lambda_cT(t-1)

            like_Y1c=log(FindDet(S1, NN))-dot_product(ep_1c, ep_1c)/(2*sige_cT(g,t-1))
            like_Y2c=log(FindDet(S2, NN))-dot_product(ep_2c, ep_2c)/(2*sige_cT(g,t-1))

            XX(:,16:30)=matmul(w,X)
            XX(:,31+DD:30+2*DD)=matmul(w,zz_1(:,1:DD))
            Y1c=matmul(XX,beta_cT(:,t-1))+alpha_cT(g,t-1)+ep_1c
            Y2c=matmul(XX,beta_cT(:,t-1))+alpha_cT(g,t-1)+ep_2c
            S1=eye(NN)-lambda_c1*(W)
            S2=eye(NN)-lambda_cT(t-1)*(W)
            CALL SGESV(NN,1,S1,NN,IPIV,Y1c,NN,INFO)
            CALL SGESV(NN,1,S2,NN,IPIV,Y2c,NN,INFO)


            XX(:,16:30)=matmul(w_new,X)
            XX(:,31+DD:30+2*DD)=matmul(w_new,zz_1(:,1:DD))
            Y3c=matmul(XX,beta_cT(:,t-1))+alpha_cT(g,t-1)+ep_2c
            Y4c=matmul(XX,beta_cT(:,t-1))+alpha_cT(g,t-1)+ep_1c
            S3=eye(NN)-lambda_cT(t-1)*(W_new)
            S4=eye(NN)-lambda_c1*(W_new)
            CALL SGESV(NN,1,S3,NN,IPIV,Y3c,NN,INFO)
            CALL SGESV(NN,1,S4,NN,IPIV,Y4c,NN,INFO)

            ep_1t=ep_1t-sige_ctT(g,t-1)/sige_cT(g,t-1)*ep_1c
            ep_2t=ep_2t-sige_ctT(g,t-1)/sige_cT(g,t-1)*ep_2c

            like_Y1t=log(FindDet(S22_new, NN-censor(g)))-dot_product(ep_1t, ep_1t)/(2*(sige_tT(g,t-1)-sige_ctT(g,t-1)/sige_cT(g,t-1)*sige_ctT(g,t-1)))
            like_Y2t=log(FindDet(S22_old, NN-censor(g)))-dot_product(ep_2t, ep_2t)/(2*(sige_tT(g,t-1)-sige_ctT(g,t-1)/sige_cT(g,t-1)*sige_ctT(g,t-1)))


            q_1=  0.5*gamma_1(13+DD)*dot_product(Y1t,Y1t)-0.5*gamma_2(13+DD)*dot_product(Y2t,Y2t) &
                &+0.5*gamma_1(14+DD)*dot_product(Y1c,Y1c)-0.5*gamma_2(14+DD)*dot_product(Y2c,Y2c) &
                &+trace(matmul(psi_1,transpose(W)),NN)- trace(matmul(psi_2,transpose(W)),NN) &
                &+(gamma_1(7+DD)-gamma_2(7+DD))*trace(matmul(W,W),NN) &
                &+(gamma_1(8+DD)-gamma_2(8+DD))*(sum(matmul(W,ones(NN,1))*matmul(W,ones(NN,1)))-sum( matmul(W,ones(NN,1)))) &
                &+(gamma_1(9+DD)-gamma_2(9+DD))*(sum(matmul(W,ones(NN,1))*(matmul(W,ones(NN,1))*matmul(W,ones(NN,1))))&
                &-2*sum(matmul(W,ones(NN,1))*matmul(W,ones(NN,1)))+sum( matmul(W,ones(NN,1))))&
                &+(gamma_1(10+DD)-gamma_2(10+DD))*(sum(matmul(ones(1,NN),W)*matmul(ones(1,NN),W))-sum( matmul(W,ones(NN,1)))) &
                &+(gamma_1(11+DD)-gamma_2(11+DD))*trace( matmul(matmul(W,W),transpose(W)),NN) &
                &+(gamma_1(12+DD)-gamma_2(12+DD))*trace( matmul(matmul(W,W),W),NN) &
                &+0.5*gamma_2(13+DD)*dot_product(Y3t,Y3t)-0.5*gamma_1(13+DD)*dot_product(Y4t,Y4t) &
                &+0.5*gamma_2(14+DD)*dot_product(Y3c,Y3c)-0.5*gamma_1(14+DD)*dot_product(Y4c,Y4c) &
                &+trace(matmul(psi_2,transpose(w_new)),NN)-trace(matmul(psi_1,transpose(w_new)),NN)  &
                &+(gamma_2(7+DD)-gamma_1(7+DD))*trace(matmul(w_new,w_new),NN) &
                &+(gamma_2(8+DD)-gamma_1(8+DD))*(sum(matmul(w_new,ones(NN,1))*matmul(w_new,ones(NN,1)))-sum(matmul(w_new,ones(NN,1)))) &
                &+(gamma_2(9+DD)-gamma_1(9+DD))*(sum(matmul(w_new,ones(NN,1))*(matmul(w_new,ones(NN,1))*matmul(w_new,ones(NN,1))))&
                &-2*sum(matmul(w_new,ones(NN,1))*matmul(w_new,ones(NN,1)))+sum(matmul(w_new,ones(NN,1))))&
                &+(gamma_2(10+DD)-gamma_1(10+DD))*(sum(matmul(ones(1,NN),w_new)*matmul(ones(1,NN),w_new))-sum(matmul(w_new,ones(NN,1)))) &
                &+(gamma_2(11+DD)-gamma_1(11+DD))*trace( matmul(matmul(w_new,w_new),transpose(w_new)),NN) &
                &+(gamma_2(12+DD)-gamma_1(12+DD))*trace( matmul(matmul(w_new,w_new),w_new),NN)

            q_g1(g)=q_1
            pp_l(g)=(like_Y1t-like_Y2t)+(like_Y1c-like_Y2c)


            DEALLOCATE(w12,wt12,w22,wt22,S22,S22_new, S22_old)
            DEALLOCATE(yr_school,C1,C2,C3,W,Wt,Yc,Yt,X,XX,ep_1t,ep_2t,ep_1c,ep_2c,Y1t,Y2t,Y1c,Y2c,Y1ts,Y2ts,Y1cs,Y2cs,Y3t,Y4t,Y3c,Y4c,Y3ts,Y4ts,Y3cs,Y4cs,h1,h2,psi,S1,S2,S3,S4,IPIV,w_old,wt_old,w_new,wt_new,pp_w,psi_1,psi_2,zz_1,zz_2,rand1,rand2,rand3)
        END DO

        !$omp end parallel

        pp_g=sum(pp_l)+sum(q_g1)+logmvnpdf(gamma_1, G_0, 14+DD)-logmvnpdf(gamma_2, G_0, 14+DD)
        CALL random_number(rand)
        IF (log(rand)<=pp_g)  THEN
            gamma_T(:,t)=gamma_1
            lambda_tT(t)=lambda_t1
            lambda_cT(t)=lambda_c1
            acc_1=acc_1+1.0
        ELSE
            gamma_T(:,t)=gamma_T(:,t-1)
            lambda_tT(t)=lambda_tT(t-1)
            lambda_cT(t)=lambda_cT(t-1)
        END IF
        acc_rate1(t)=acc_1/t

        xi_T(1:14+DD,t)=gamma_T(:,t)
        xi_T(15+DD,t)=lambda_tT(t)
        xi_T(16+DD,t)=lambda_cT(t)



        !******************M-H STEP FOR BETA --both continuous outcomes *****************!

        cov_beta_1=eye(30+2*DD)*c_2
        call spotrf('U', 30+2*DD, cov_beta_1, 30+2*DD,info)
        errcode=vsrnggaussianmv( method_gaussian, stream_gaussian, 1, beta_1c, 30+2*DD, me, beta_0, cov_beta_1)
        beta_1c=beta_1c+beta_cT(:,t-1)

        IF (t>1000) THEN
            cov_beta_1=cov(beta_cT(:,1:t-1),30+2*DD,t-1)*2.38**2/(30+2*DD)
            call spotrf('U', 30+2*DD, cov_beta_1, 30+2*DD,info)
            errcode=vsrnggaussianmv(method_gaussian,stream_gaussian,1, beta_2c, 30+2*DD, me, beta_0, cov_beta_1)
            beta_2c= beta_2c+beta_cT(:,t-1)
            beta_1c=0.8*beta_2c+0.2*beta_1c
        END IF

        pp_b=0.0

        Call OMP_SET_NUM_THREADS(Nthreads)
        !$omp parallel default(shared) private(g,NN,C1,C2,C3,W,Wt,Yc,Yt,X,XX,yr_school, &
        !$omp & ep_1t,ep_2t,ep_1c,ep_2c, h1,h2, i, j, psi, zz_1, w12,wt12,w22,wt22,S22, &
        !$omp & IPIV,INFO, S1,S2, S3, S4, w_old,w_new,r,w1,w2,w3,w4, pp_w, wt_old,wt_new, &
        !$omp & q,rand, Y1t,Y2t,Y1c,Y2c, Y3t,Y4t, Y3c, Y4c,Y1ts,Y2ts,Y1cs,Y2cs,Y3ts,Y4ts, Y3cs, Y4cs,&
        !$omp & errcode, rand1, rand2, rand3,   &
        !$omp & like_Y1t,like_Y2t, like_Y1c,like_Y2c, q_1, ithread, iblock, ibegin, iend)

        ithread = OMP_GET_THREAD_NUM()
        iblock = (GG+Nthreads-1)/Nthreads
        ibegin = ithread*iblock+1
        iend = min((ithread+1)*iblock,GG)

        DO g = ibegin,iend

            NN=N(g)
            ALLOCATE(yr_school(NN));
            ALLOCATE(C1(NN,NN));   ALLOCATE(C2(NN,NN));  ALLOCATE(C3(NN,NN))
            ALLOCATE(W(NN,NN));    ALLOCATE(Wt(NN,NN));
            ALLOCATE(Yc(NN));      ALLOCATE(Yt(NN));
            ALLOCATE(X(NN,15));    ALLOCATE(XX(NN,30+2*DD))
            ALLOCATE(ep_1t(NN));   ALLOCATE(ep_2t(NN));
            ALLOCATE(ep_1c(NN));   ALLOCATE(ep_2c(NN));
            ALLOCATE(Y1t(NN));     ALLOCATE(Y2t(NN));
            ALLOCATE(Y1c(NN));     ALLOCATE(Y2c(NN));
            ALLOCATE(Y1ts(NN));    ALLOCATE(Y2ts(NN));
            ALLOCATE(Y1cs(NN));    ALLOCATE(Y2cs(NN));
            ALLOCATE(Y3t(NN));     ALLOCATE(Y4t(NN));
            ALLOCATE(Y3c(NN));     ALLOCATE(Y4c(NN));
            ALLOCATE(Y3ts(NN));    ALLOCATE(Y4ts(NN));
            ALLOCATE(Y3cs(NN));    ALLOCATE(Y4cs(NN));
            ALLOCATE(h1(NN));      ALLOCATE(h2(NN));
            ALLOCATE(psi(NN,NN));
            ALLOCATE(S1(NN,NN));   ALLOCATE(S2(NN,NN));
            ALLOCATE(S3(NN,NN));   ALLOCATE(S4(NN,NN));
            ALLOCATE(IPIV(NN))
            ALLOCATE(w_old(NN,NN));ALLOCATE(w_new(NN,NN));
            ALLOCATE(wt_old(NN,NN));ALLOCATE(wt_new(NN,NN));
            ALLOCATE(pp_w(NN,NN))
            ALLOCATE(zz_1(NN,DD))
            ALLOCATE(rand1(RR));        ALLOCATE(rand2(RR));
            ALLOCATE(rand3(RR));

            C1=age(1:NN,1:NN,g)
            C2=sex(1:NN,1:NN,g)
            C3=race(1:NN,1:NN,g)
            W=network(1:NN,1:NN,g)
            Wt=transpose(W)
            Yt=Yt_latent(1:NN,g)
            Yc=Yc_latent(1:NN,g)
            X=group(1:NN,1:15,g)
            zz_1=zz(1:NN,1:DD,g)
            XX(:,1:15)=X
            XX(:,16:30)=matmul(W,X)
            XX(:,31:30+DD)=zz_1(:,1:DD)
            XX(:,31+DD:30+2*DD)=matmul(W,zz_1(:,1:DD))
            yr_school=group(1:NN,18,g)

            ALLOCATE(w12(censor(g),NN-censor(g)))
            ALLOCATE(w22(NN-censor(g),NN-censor(g)))
            ALLOCATE(wt12(censor(g),NN-censor(g)))
            ALLOCATE(wt22(NN-censor(g),NN-censor(g)))
            ALLOCATE(S22(NN-censor(g),NN-censor(g)))
            w12=W(1:censor(g),censor(g)+1:NN)
            w22=W(censor(g)+1:NN,censor(g)+1:NN)
            wt12=Wt(1:censor(g),censor(g)+1:NN)
            wt22=Wt(censor(g)+1:NN,censor(g)+1:NN)
            S22=eye(NN-censor(g))-lambda_tT(t)*(W22)

            !! Define Epsilon !!
            ep_1t(1:censor(g))=Yt(1:censor(g))-( lambda_tT(t)*matmul(W12,Yt(censor(g)+1:NN))+matmul(XX(1:censor(g),:),beta_tT(:,t-1))+alpha_tT(g,t-1))
            ep_1t(censor(g)+1:NN)=matmul(S22,Yt(censor(g)+1:NN))-matmul(XX(censor(g)+1:NN,:),beta_tT(:,t-1))-alpha_tT(g,t-1)

            ep_2t=ep_1t

            S1=eye(NN)-(W)*lambda_cT(t)
            ep_1c=matmul(S1,Yc)-matmul(XX,beta_1c)       -alpha_cT(g,t-1)
            ep_2c=matmul(S1,Yc)-matmul(XX,beta_cT(:,t-1))-alpha_cT(g,t-1)

            psi=0.0
            DO i=1, NN
                DO j=1, NN
                    If (j /=i) THEN
                        IF (DD==1) THEN
                            psi(i,j)=gamma_T(1,t)+gamma_T(2,t)*C1(i,j)+gamma_T(3,t)*C2(i,j) +gamma_T(4,t)*C3(i,j) &
                                & +gamma_T(5,t)*yr_school(i)+gamma_T(6,t)*yr_school(j)-gamma_T(7,t)*abs(zz_1(i,1)-zz_1(j,1))
                        ELSEIF(DD==2) THEN
                            psi(i,j)=gamma_T(1,t)+gamma_T(2,t)*C1(i,j)+gamma_T(3,t)*C2(i,j) +gamma_T(4,t)*C3(i,j) &
                                & +gamma_T(5,t)*yr_school(i)+gamma_T(6,t)*yr_school(j)-gamma_T(7,t)*abs(zz_1(i,1)-zz_1(j,1))-gamma_T(8,t)*abs(zz_1(i,2)-zz_1(j,2))
                        ELSEIF(DD==3) THEN
                            psi(i,j)=gamma_T(1,t)+gamma_T(2,t)*C1(i,j)+gamma_T(3,t)*C2(i,j) +gamma_T(4,t)*C3(i,j) &
                                & +gamma_T(5,t)*yr_school(i)+gamma_T(6,t)*yr_school(j)-gamma_T(7,t)*abs(zz_1(i,1)-zz_1(j,1))-gamma_T(8,t)*abs(zz_1(i,2)-zz_1(j,2))-gamma_T(9,t)*abs(zz_1(i,3)-zz_1(j,3))
                        ENDIF
                    END IF
                END DO
            END DO

            Y2c=Yc
            W_new=W
            W_old=W
            Wt_new=Wt
            Wt_old=Wt

            errcode=vsrnguniform( method_uniform, stream_uniform, RR, rand1, 0.0, 1.0)
            errcode=vsrnguniform( method_uniform, stream_uniform, RR, rand2, 0.0, 1.0)
            errcode=vsrnguniform( method_uniform, stream_uniform, RR, rand3, 0.0, 1.0)

            rand1=FLOOR(rand1*NN)
            rand2=FLOOR(rand2*NN)
            rand3=log(rand3)

            DO r=1, RR
                i=rand1(r)
                j=rand2(r)

                !DO i=1, NN
                !    DO j=1, NN
                IF ((i>=1) .and. (i<=NN) .and. (j>=1) .and. (j<=NN) .and. (j /= i)) THEN
                    w_new(i,j)=1-w_new(i,j)
                    XX(i,16:30)=matmul(w_new(i,:),X)
                    XX(i,31+DD:30+2*DD)=matmul(w_new(i,:),zz_1(:,1:DD))
                    h1=ep_1t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)
                    CALL contraction(NN,h1,w_new,lambda_tT(t),Y1t)

                    S1=eye(NN)-(W_new)*lambda_cT(t)
                    Y1c=ep_1c+matmul(XX,beta_1c)+alpha_cT(g,t-1)
                    CALL SGESV(NN,1,S1,NN,IPIV,Y1c,NN,INFO)

                    XX(i,16:30)=matmul(w_old(i,:),X)
                    XX(i,31+DD:30+2*DD)=matmul(w_old(i,:),zz_1(:,1:DD))
                    h1=ep_1t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)
                    CALL contraction(NN,h1,w_old,lambda_tT(t),Y2t)


                    w1=dot_product(w_new(i,:),w_new(j,:))
                    w2=dot_product(w_new(:,i),w_new(:,j))
                    w3=dot_product(w_new(i,:),w_new(:,j))
                    w4=dot_product(w_new(j,:),w_new(:,i))

                    q=psi(i,j)+2*gamma_T(7+DD,t)*w_new(j,i)+(2*gamma_T(8+DD,t)-gamma_T(9+DD,t))*(sum(w_new(i,:))-w_new(i,j)) &
                        &+3*gamma_T(9+DD,t)*(sum(w_new(i,:))-w_new(i,j))**2 &
                        &+2*gamma_T(10+DD,t)*(sum(w_new(:,j))-w_new(i,j))+gamma_T(11+DD,t)*(w1+w2+w3)+gamma_T(12+DD,t)*3*w4

                    pp_w(i,j)=q*(-1)**(1-w_new(i,j))+0.5*gamma_T(13+DD,t)*(dot_product(Y1t,Y1t)-dot_product(Y2t,Y2t)) &
                        & + 0.5*gamma_T(14+DD,t)*(dot_product(Y1c,Y1c)-dot_product(Y2c,Y2c))

                    !CALL random_number(rand)
                    IF (rand3(r)<=pp_w(i,j)) then
                        W_old(i,j)=W_new(i,j)
                        Y2c=Y1c
                    END IF
                    W_new(i,j)=W_old(i,j)
                    XX(i,16:30)=matmul(w_new(i,:),X)
                    XX(i,31+DD:30+2*DD)=matmul(w_new(i,:),zz_1(:,1:DD))
                END IF
                !    END DO
                !END DO
            END DO

            like_Y1c=-1*dot_product(ep_1c, ep_1c)/(2*sige_cT(g,t-1))
            like_Y2c=-1*dot_product(ep_2c, ep_2c)/(2*sige_cT(g,t-1))

            XX(:,1:15)=X
            XX(:,16:30)=matmul(w_new,X)
            XX(:,31:30+DD)=zz_1(:,1:DD)
            XX(:,31+DD:30+2*DD)=matmul(w_new,zz_1(:,1:DD))

            Y3c=matmul(XX,beta_cT(:,t-1))+alpha_cT(g,t-1)+ep_2c
            Y4c=matmul(XX,beta_1c)       +alpha_cT(g,t-1)+ep_1c
            S3=eye(NN)-lambda_cT(t)*(W_new)
            S4=eye(NN)-lambda_cT(t)*(W_new)
            CALL SGESV(NN,1,S3,NN,IPIV,Y3c,NN,INFO)
            CALL SGESV(NN,1,S4,NN,IPIV,Y4c,NN,INFO)

            ep_1t=ep_1t-sige_ctT(g,t-1)/sige_cT(g,t-1)*ep_1c
            ep_2t=ep_2t-sige_ctT(g,t-1)/sige_cT(g,t-1)*ep_2c

            like_Y1t=-1*dot_product(ep_1t, ep_1t)/(2*(sige_tT(g,t-1)-sige_ctT(g,t-1)/sige_cT(g,t-1)*sige_ctT(g,t-1)))
            like_Y2t=-1*dot_product(ep_2t, ep_2t)/(2*(sige_tT(g,t-1)-sige_ctT(g,t-1)/sige_cT(g,t-1)*sige_ctT(g,t-1)))


            pp_b(g)=(like_Y1t-like_Y2t)+(like_Y1c-like_Y2c)+0.5*gamma_T(14+DD,t)*(dot_product(Y3c,Y3c)-dot_product(Y4c,Y4c))

            DEALLOCATE(w12,wt12,w22,wt22,S22)
            DEALLOCATE(yr_school,C1,C2,C3,W,Wt,Yc,Yt,X,XX,ep_1t,ep_2t,ep_1c,ep_2c,Y1t,Y2t,Y1c,Y2c,Y3t,Y4t,Y3c,Y4c,Y1ts,Y2ts,Y1cs,Y2cs,Y3ts,Y4ts,Y3cs,Y4cs,h1,h2,psi,S1,S2,S3,S4,IPIV,w_old,w_new,wt_old,wt_new,pp_w,zz_1,rand1,rand2,rand3)

        END DO
        !$omp end parallel

        pp_g=sum(pp_b)+logmvnpdf(beta_1c, B_0, 30+2*DD)-logmvnpdf(beta_cT(:,t-1), B_0, 30+2*DD)
        CALL random_number(rand)
        IF (log(rand)<=pp_g)  THEN
            beta_cT(:,t)=beta_1c
            acc_2=acc_2+1.0
        ELSE
            beta_cT(:,t)=beta_cT(:,t-1)
        END IF
        acc_rate2(t)=acc_2/t


        !******************M-H STEP FOR BETA --Tobit outcomes *****************!


        cov_beta_1=eye(30+2*DD)*c_6
        call spotrf('U', 30+2*DD, cov_beta_1, 30+2*DD,info)
        errcode=vsrnggaussianmv( method_gaussian, stream_gaussian, 1, beta_1t, 30+2*DD, me, beta_0, cov_beta_1)
        beta_1t=beta_1t+beta_tT(:,t-1)

        IF (t>1000) THEN
            cov_beta_1=cov(beta_tT(:,1:t-1),30+2*DD,t-1)*2.38**2/(30+2*DD)
            call spotrf('U', 30+2*DD, cov_beta_1, 30+2*DD,info)
            errcode=vsrnggaussianmv(method_gaussian,stream_gaussian,1, beta_2t, 30+2*DD, me, beta_0, cov_beta_1)
            beta_2t=beta_2t+beta_tT(:,t-1)
            beta_1t=0.8*beta_2t+0.2*beta_1t
        END IF

        pp_b=0.0

        Call OMP_SET_NUM_THREADS(Nthreads)
        !$omp parallel default(shared) private(g,NN,C1,C2,C3,W,Wt,Yc,Yt,X,XX,yr_school, zz_1, &
        !$omp & w12,wt12,w22,wt22, S22, ep_1t,ep_2t, ep_1c,ep_2c, h1,h2, i, j, psi,  &
        !$omp & IPIV,INFO, S1,S2,S3,S4, w_old,w_new,wt_old,wt_new,r,w1,w2,w3,w4,Y1t,Y2t,Y1c,Y2c, pp_w, &
        !$omp & q,rand,Y3t,Y4t,Y3c,Y4c, Y1ts,Y2ts,Y1cs,Y2cs, Y3ts,Y4ts,Y3cs,Y4cs,&
        !$omp & errcode, rand1, rand2, rand3, &
        !$omp & like_Y1t,like_Y2t, like_Y1c,like_Y2c, q_1, ithread, iblock, ibegin, iend)

        ithread = OMP_GET_THREAD_NUM()
        iblock = (GG+Nthreads-1)/Nthreads
        ibegin = ithread*iblock+1
        iend = min((ithread+1)*iblock,GG)

        DO g = ibegin,iend
            NN=N(g)
            ALLOCATE(yr_school(NN));
            ALLOCATE(C1(NN,NN));   ALLOCATE(C2(NN,NN));  ALLOCATE(C3(NN,NN))
            ALLOCATE(W(NN,NN));    ALLOCATE(Wt(NN,NN));
            ALLOCATE(Yc(NN));      ALLOCATE(Yt(NN));
            ALLOCATE(X(NN,15));    ALLOCATE(XX(NN,30+2*DD))
            ALLOCATE(ep_1t(NN));   ALLOCATE(ep_2t(NN));
            ALLOCATE(ep_1c(NN));   ALLOCATE(ep_2c(NN));
            ALLOCATE(Y1t(NN));     ALLOCATE(Y2t(NN));
            ALLOCATE(Y1c(NN));     ALLOCATE(Y2c(NN));
            ALLOCATE(Y1ts(NN));    ALLOCATE(Y2ts(NN));
            ALLOCATE(Y1cs(NN));    ALLOCATE(Y2cs(NN));
            ALLOCATE(Y3t(NN));     ALLOCATE(Y4t(NN));
            ALLOCATE(Y3c(NN));     ALLOCATE(Y4c(NN));
            ALLOCATE(Y3ts(NN));    ALLOCATE(Y4ts(NN));
            ALLOCATE(Y3cs(NN));    ALLOCATE(Y4cs(NN));
            ALLOCATE(h1(NN));      ALLOCATE(h2(NN));
            ALLOCATE(psi(NN,NN));
            ALLOCATE(S1(NN,NN));   ALLOCATE(S2(NN,NN));
            ALLOCATE(S3(NN,NN));   ALLOCATE(S4(NN,NN));
            ALLOCATE(IPIV(NN))
            ALLOCATE(w_old(NN,NN));ALLOCATE(w_new(NN,NN));
            ALLOCATE(wt_old(NN,NN));ALLOCATE(wt_new(NN,NN));
            ALLOCATE(pp_w(NN,NN))
            ALLOCATE(zz_1(NN,DD))
            ALLOCATE(rand1(RR));        ALLOCATE(rand2(RR));
            ALLOCATE(rand3(RR));

            C1=age(1:NN,1:NN,g)
            C2=sex(1:NN,1:NN,g)
            C3=race(1:NN,1:NN,g)
            W=network(1:NN,1:NN,g)
            Wt=transpose(W)
            Yt=Yt_latent(1:NN,g)
            Yc=Yc_latent(1:NN,g)
            X=group(1:NN,1:15,g)
            zz_1=zz(1:NN,1:DD,g)
            XX(:,1:15)=X
            XX(:,16:30)=matmul(W,X)
            XX(:,31:30+DD)=zz_1(:,1:DD)
            XX(:,31+DD:30+2*DD)=matmul(W,zz_1(:,1:DD))
            yr_school=group(1:NN,18,g)

            ALLOCATE(w12(censor(g),NN-censor(g)))
            ALLOCATE(w22(NN-censor(g),NN-censor(g)))
            ALLOCATE(wt12(censor(g),NN-censor(g)))
            ALLOCATE(wt22(NN-censor(g),NN-censor(g)))
            ALLOCATE(S22(NN-censor(g),NN-censor(g)))
            w12=W(1:censor(g),censor(g)+1:NN)
            w22=W(censor(g)+1:NN,censor(g)+1:NN)
            wt12=Wt(1:censor(g),censor(g)+1:NN)
            wt22=Wt(censor(g)+1:NN,censor(g)+1:NN)
            S22=eye(NN-censor(g))-lambda_tT(t)*(W22)

            !! Define Epsilon !!
            ep_1t(1:censor(g))=Yt(1:censor(g))-(lambda_tT(t)*matmul(W12,Yt(censor(g)+1:NN))+matmul(XX(1:censor(g),:),beta_1t)+alpha_tT(g,t-1))
            ep_1t(censor(g)+1:NN)=matmul(S22,Yt(censor(g)+1:NN))-matmul(XX(censor(g)+1:NN,:),beta_1t)-alpha_tT(g,t-1)

            ep_2t(1:censor(g))=Yt(1:censor(g))-(lambda_tT(t)*matmul(W12,Yt(censor(g)+1:NN))+matmul(XX(1:censor(g),:),beta_tT(:,t-1))+alpha_tT(g,t-1))
            ep_2t(censor(g)+1:NN)=matmul(S22,Yt(censor(g)+1:NN))-matmul(XX(censor(g)+1:NN,:),beta_tT(:,t-1))-alpha_tT(g,t-1)

            S1=eye(NN)-(W)*lambda_cT(t)
            ep_1c=matmul(S1,Yc)-matmul(XX,beta_cT(:,t))-alpha_cT(g,t-1)

            psi=0.0
            DO i=1, NN
                DO j=1, NN
                    IF (j /= i) THEN
                        IF (DD==1) THEN
                            psi(i,j)=gamma_T(1,t)+gamma_T(2,t)*C1(i,j)+gamma_T(3,t)*C2(i,j) +gamma_T(4,t)*C3(i,j) &
                                & +gamma_T(5,t)*yr_school(i)+gamma_T(6,t)*yr_school(j)-gamma_T(7,t)*abs(zz_1(i,1)-zz_1(j,1))
                        ELSEIF(DD==2) THEN
                            psi(i,j)=gamma_T(1,t)+gamma_T(2,t)*C1(i,j)+gamma_T(3,t)*C2(i,j) +gamma_T(4,t)*C3(i,j) &
                                & +gamma_T(5,t)*yr_school(i)+gamma_T(6,t)*yr_school(j)-gamma_T(7,t)*abs(zz_1(i,1)-zz_1(j,1))-gamma_T(8,t)*abs(zz_1(i,2)-zz_1(j,2))
                        ELSEIF(DD==3) THEN
                            psi(i,j)=gamma_T(1,t)+gamma_T(2,t)*C1(i,j)+gamma_T(3,t)*C2(i,j) +gamma_T(4,t)*C3(i,j) &
                                & +gamma_T(5,t)*yr_school(i)+gamma_T(6,t)*yr_school(j)-gamma_T(7,t)*abs(zz_1(i,1)-zz_1(j,1))-gamma_T(8,t)*abs(zz_1(i,2)-zz_1(j,2))-gamma_T(9,t)*abs(zz_1(i,3)-zz_1(j,3))
                        ENDIF
                    ENDIF
                END DO
            END DO

            Y2c=Yc
            W_new=W
            W_old=W

            errcode=vsrnguniform( method_uniform, stream_uniform, RR, rand1, 0.0, 1.0)
            errcode=vsrnguniform( method_uniform, stream_uniform, RR, rand2, 0.0, 1.0)
            errcode=vsrnguniform( method_uniform, stream_uniform, RR, rand3, 0.0, 1.0)

            rand1=FLOOR(rand1*NN)
            rand2=FLOOR(rand2*NN)
            rand3=log(rand3)

            DO r=1, RR
                i=rand1(r)
                j=rand2(r)

                !DO i=1, NN
                !    DO j=1, NN
                IF ((i>=1) .and. (i<=NN) .and. (j>=1) .and. (j<=NN) .and. (j /= i)) THEN
                    w_new(i,j)=1-w_new(i,j)
                    XX(i,16:30)=matmul(w_new(i,:),X)
                    XX(i,31+DD:30+2*DD)=matmul(w_new(i,:),zz_1(:,1:DD))
                    h1=ep_1t+matmul(XX,beta_1t)+alpha_tT(g,t-1)
                    CALL contraction(NN,h1,w_new,lambda_tT(t),Y1t)

                    S1=eye(NN)-(W_new)*lambda_cT(t)
                    Y1c=ep_1c+matmul(XX,beta_cT(:,t))+alpha_cT(g,t-1)
                    CALL SGESV(NN,1,S1,NN,IPIV,Y1c,NN,INFO)

                    XX(i,16:30)=matmul(w_old(i,:),X)
                    XX(i,31+DD:30+2*DD)=matmul(w_old(i,:),zz_1(:,1:DD))
                    h1=ep_1t+matmul(XX,beta_1t)+alpha_tT(g,t-1)
                    CALL contraction(NN,h1,w_old,lambda_tT(t),Y2t)

                    w1=dot_product(w_new(i,:),w_new(j,:))
                    w2=dot_product(w_new(:,i),w_new(:,j))
                    w3=dot_product(w_new(i,:),w_new(:,j))
                    w4=dot_product(w_new(j,:),w_new(:,i))

                    q=psi(i,j)+2*gamma_T(7+DD,t)*w_new(j,i)+(2*gamma_T(8+DD,t)-gamma_T(9+DD,t))*(sum(w_new(i,:))-w_new(i,j)) &
                        &+3*gamma_T(9+DD,t)*(sum(w_new(i,:))-w_new(i,j))**2 &
                        &+2*gamma_T(10+DD,t)*(sum(w_new(:,j))-w_new(i,j))+gamma_T(11+DD,t)*(w1+w2+w3)+gamma_T(12+DD,t)*3*w4

                    pp_w(i,j)=q*(-1)**(1-w_new(i,j))+0.5*gamma_T(13+DD,t)*(dot_product(Y1t,Y1t)-dot_product(Y2t,Y2t)) &
                        & + 0.5*gamma_T(14+DD,t)*(dot_product(Y1c,Y1c)-dot_product(Y2c,Y2c))

                    !CALL random_number(rand)
                    IF (rand3(r)<=pp_w(i,j)) then
                        W_old(i,j)=W_new(i,j)
                        Y2c=Y1c
                    END IF
                    W_new(i,j)=W_old(i,j)
                    XX(i,16:30)=matmul(w_new(i,:),X)
                    XX(i,31+DD:30+2*DD)=matmul(w_new(i,:),zz_1(:,1:DD))
                END IF
                !    END DO
                !END DO
            END DO

            XX(:,1:15)=X
            XX(:,16:30)=matmul(w,X)
            XX(:,31:30+DD)=zz_1(:,1:DD)
            XX(:,31+DD:30+2*DD)=matmul(W,zz_1(:,1:DD))
            h1=ep_1t+matmul(XX,beta_1t)       +alpha_tT(g,t-1)
            h2=ep_2t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)

            CALL contraction(NN,h1,W,lambda_tT(t),Y1t)
            CALL contraction(NN,h2,W,lambda_tT(t),Y2t)

            XX(:,16:30)=matmul(w_new,X)
            XX(:,31+DD:30+2*DD)=matmul(w_new,zz_1(:,1:DD))
            h1=ep_1t+matmul(XX,beta_1t)       +alpha_tT(g,t-1)
            h2=ep_2t+matmul(XX,beta_tT(:,t-1))+alpha_tT(g,t-1)

            CALL contraction(NN,h2,w_new,lambda_tT(t),Y3t)
            CALL contraction(NN,h1,w_new,lambda_tT(t),Y4t)

            ep_1t=ep_1t-sige_ctT(g,t-1)/sige_cT(g,t-1)*ep_1c
            ep_2t=ep_2t-sige_ctT(g,t-1)/sige_cT(g,t-1)*ep_1c

            like_Y1t=-1*dot_product(ep_1t, ep_1t)/(2*(sige_tT(g,t-1)-sige_ctT(g,t-1)/sige_cT(g,t-1)*sige_ctT(g,t-1)))
            like_Y2t=-1*dot_product(ep_2t, ep_2t)/(2*(sige_tT(g,t-1)-sige_ctT(g,t-1)/sige_cT(g,t-1)*sige_ctT(g,t-1)))

            pp_b(g)=(like_Y1t-like_Y2t)+0.5*(gamma_T(13+DD,t)*(dot_product(Y1t,Y1t)+dot_product(Y3t,Y3t)-dot_product(Y2t,Y2t)-dot_product(Y4t,Y4t)))

            DEALLOCATE(w12,wt12,w22,wt22,S22)

            DEALLOCATE(yr_school,C1,C2,C3,W,Wt,Yc,Yt,X,XX,ep_1t,ep_2t,ep_1c,ep_2c,Y1t,Y2t,Y1c,Y2c,Y3t,Y4t,Y3c,Y4c,Y1ts,Y2ts,Y1cs,Y2cs,Y3ts,Y4ts,Y3cs,Y4cs,h1,h2,psi,S1,S2,S3,S4,IPIV,w_old,w_new,wt_old,wt_new,pp_w,zz_1,rand1,rand2,rand3)
        END DO
        !$omp end parallel


        pp_g=sum(pp_b)+logmvnpdf(beta_1t, B_0, 30+2*DD)-logmvnpdf(beta_tT(:,t-1), B_0, 30+2*DD)


        CALL random_number(rand)
        IF (log(rand)<=pp_g)  THEN
            beta_tT(:,t)=beta_1t
            acc_6=acc_6+1.0
        ELSE
            beta_tT(:,t)=beta_tT(:,t-1)
        END IF
        acc_rate6(t)=acc_6/t




        !******************M-H STEP FOR ALPHA --both Tobit and continuous outcomes *****************!


        Call OMP_SET_NUM_THREADS(Nthreads)
        !$omp parallel default(shared) private(alpha_1t, alpha_1c,g,NN,C1,C2,C3,W,Wt,Yc,Yt,X,XX,yr_school, X_bar, zz_1, &
        !$omp & w12,wt12,w22,wt22,S22,ep_1t,ep_2t,ep_1c,ep_2c, h1,h2, i, j, psi, alpha_temp1, alpha_temp1v, &
        !$omp & alpha_temp2, alpha_temp2v, IPIV,INFO, S1,S2, S3, S4, w_old,w_new,wt_new,wt_old, r,w1,w2,w3,w4,&
        !$omp & Y1t,Y2t,Y1c,Y2c, pp_w, q,rand,Y3t,Y4t, Y3c, Y4c, Y1ts,Y2ts,Y1cs,Y2cs, Y3ts,Y4ts, Y3cs, Y4cs, pp, &
        !$omp & errcode, rand1, rand2, rand3,   &
        !$omp & like_Y1t,like_Y2t, like_Y1c,like_Y2c, q_1, ithread, iblock, ibegin, iend)

        ithread = OMP_GET_THREAD_NUM()
        iblock = (GG+Nthreads-1)/Nthreads
        ibegin = ithread*iblock+1
        iend = min((ithread+1)*iblock,GG)

        DO g = ibegin,iend

            alpha_1t=alpha_tT(g,t-1)+random_normal()*sqrt(c_3(g))
            alpha_1c=alpha_cT(g,t-1)+random_normal()*sqrt(c_3(g))

            NN=N(g)
            ALLOCATE(yr_school(NN));
            ALLOCATE(C1(NN,NN));   ALLOCATE(C2(NN,NN));  ALLOCATE(C3(NN,NN))
            ALLOCATE(W(NN,NN));    ALLOCATE(Wt(NN,NN));
            ALLOCATE(Yc(NN));      ALLOCATE(Yt(NN));
            ALLOCATE(X(NN,15));    ALLOCATE(XX(NN,30+2*DD))
            ALLOCATE(X_bar(15+DD));
            ALLOCATE(ep_1t(NN));   ALLOCATE(ep_2t(NN));
            ALLOCATE(ep_1c(NN));   ALLOCATE(ep_2c(NN));
            ALLOCATE(Y1t(NN));     ALLOCATE(Y2t(NN));
            ALLOCATE(Y1c(NN));     ALLOCATE(Y2c(NN));
            ALLOCATE(Y1ts(NN));    ALLOCATE(Y2ts(NN));
            ALLOCATE(Y1cs(NN));    ALLOCATE(Y2cs(NN));
            ALLOCATE(Y3t(NN));     ALLOCATE(Y4t(NN));
            ALLOCATE(Y3c(NN));     ALLOCATE(Y4c(NN));
            ALLOCATE(Y3ts(NN));    ALLOCATE(Y4ts(NN));
            ALLOCATE(Y3cs(NN));    ALLOCATE(Y4cs(NN));
            ALLOCATE(h1(NN));      ALLOCATE(h2(NN));
            ALLOCATE(psi(NN,NN));
            ALLOCATE(S1(NN,NN));   ALLOCATE(S2(NN,NN));
            ALLOCATE(S3(NN,NN));   ALLOCATE(S4(NN,NN));
            ALLOCATE(IPIV(NN))
            ALLOCATE(w_old(NN,NN));ALLOCATE(w_new(NN,NN));
            ALLOCATE(wt_old(NN,NN));ALLOCATE(wt_new(NN,NN));
            ALLOCATE(pp_w(NN,NN))
            ALLOCATE(zz_1(NN,DD))
            ALLOCATE(rand1(RR));        ALLOCATE(rand2(RR));
            ALLOCATE(rand3(RR));


            C1=age(1:NN,1:NN,g)
            C2=sex(1:NN,1:NN,g)
            C3=race(1:NN,1:NN,g)
            W=network(1:NN,1:NN,g)
            Wt=transpose(W)
            Yt=Yt_latent(1:NN,g)
            Yc=Yc_latent(1:NN,g)
            X=group(1:NN,1:15,g)
            zz_1=zz(1:NN,1:DD,g)
            XX(:,1:15)=X
            XX(:,16:30)=matmul(W,X)
            XX(:,31:30+DD)=zz_1(:,1:DD)
            XX(:,31+DD:30+2*DD)=matmul(W,zz_1(:,1:DD))
            yr_school=group(1:NN,18,g)

            ALLOCATE(w12(censor(g),NN-censor(g)))
            ALLOCATE(w22(NN-censor(g),NN-censor(g)))
            ALLOCATE(wt12(censor(g),NN-censor(g)))
            ALLOCATE(wt22(NN-censor(g),NN-censor(g)))
            ALLOCATE(S22(NN-censor(g),NN-censor(g)))
            w12=W(1:censor(g),censor(g)+1:NN)
            w22=W(censor(g)+1:NN,censor(g)+1:NN)
            wt12=Wt(1:censor(g),censor(g)+1:NN)
            wt22=Wt(censor(g)+1:NN,censor(g)+1:NN)
            S22=eye(NN-censor(g))-lambda_tT(t)*(W22)

            !! Define Epsilon !!
            ep_1t(1:censor(g))=Yt(1:censor(g))-(lambda_tT(t)*matmul(W12,Yt(censor(g)+1:NN))+matmul(XX(1:censor(g),:),beta_tT(:,t))+alpha_1t)
            ep_1t(censor(g)+1:NN)=matmul(S22,Yt(censor(g)+1:NN))-matmul(XX(censor(g)+1:NN,:),beta_tT(:,t))-alpha_1t

            ep_2t(1:censor(g))=Yt(1:censor(g))-(lambda_tT(t)*matmul(W12,Yt(censor(g)+1:NN))+matmul(XX(1:censor(g),:),beta_tT(:,t))+alpha_tT(g,t-1))
            ep_2t(censor(g)+1:NN)=matmul(S22,Yt(censor(g)+1:NN))-matmul(XX(censor(g)+1:NN,:),beta_tT(:,t))-alpha_tT(g,t-1)

            S1=eye(NN)-(W)*lambda_cT(t)
            ep_1c=matmul(S1,Yc)-matmul(XX,beta_cT(:,t))-alpha_1c
            ep_2c=matmul(S1,Yc)-matmul(XX,beta_cT(:,t))-alpha_cT(g,t-1)

            psi=0.0
            DO i=1, NN
                DO j=1, NN
                    IF (j /= i) THEN
                        IF (DD==1) THEN
                            psi(i,j)=gamma_T(1,t)+gamma_T(2,t)*C1(i,j)+gamma_T(3,t)*C2(i,j) +gamma_T(4,t)*C3(i,j) &
                                & +gamma_T(5,t)*yr_school(i)+gamma_T(6,t)*yr_school(j)-gamma_T(7,t)*abs(zz_1(i,1)-zz_1(j,1))
                        ELSEIF(DD==2) THEN
                            psi(i,j)=gamma_T(1,t)+gamma_T(2,t)*C1(i,j)+gamma_T(3,t)*C2(i,j) +gamma_T(4,t)*C3(i,j) &
                                & +gamma_T(5,t)*yr_school(i)+gamma_T(6,t)*yr_school(j)-gamma_T(7,t)*abs(zz_1(i,1)-zz_1(j,1))-gamma_T(8,t)*abs(zz_1(i,2)-zz_1(j,2))
                        ELSEIF(DD==3) THEN
                            psi(i,j)=gamma_T(1,t)+gamma_T(2,t)*C1(i,j)+gamma_T(3,t)*C2(i,j) +gamma_T(4,t)*C3(i,j) &
                                & +gamma_T(5,t)*yr_school(i)+gamma_T(6,t)*yr_school(j)-gamma_T(7,t)*abs(zz_1(i,1)-zz_1(j,1))-gamma_T(8,t)*abs(zz_1(i,2)-zz_1(j,2))-gamma_T(9,t)*abs(zz_1(i,3)-zz_1(j,3))
                        ENDIF
                    ENDIF
                END DO
            END DO

            Y2c=Yc_latent(1:NN,g)
            W_new=W
            W_old=W

            errcode=vsrnguniform( method_uniform, stream_uniform, RR, rand1, 0.0, 1.0)
            errcode=vsrnguniform( method_uniform, stream_uniform, RR, rand2, 0.0, 1.0)
            errcode=vsrnguniform( method_uniform, stream_uniform, RR, rand3, 0.0, 1.0)

            rand1=FLOOR(rand1*NN)
            rand2=FLOOR(rand2*NN)
            rand3=log(rand3)

            DO r=1, RR
                i=rand1(r)
                j=rand2(r)

                !DO i=1, NN
                !    DO j=1, NN
                IF ((i>=1) .and. (i<=NN) .and. (j>=1) .and. (j<=NN) .and. (j /= i)) THEN
                    w_new(i,j)=1-w_new(i,j)
                    XX(i,16:30)=matmul(w_new(i,:),X)
                    XX(i,31+DD:30+2*DD)=matmul(w_new(i,:),zz_1(:,1:DD))
                    h1=ep_1t+matmul(XX,beta_tT(:,t))+alpha_1t
                    CALL contraction(NN,h1,w_new,lambda_tT(t),Y1t)

                    S1=eye(NN)-(W_new)*lambda_cT(t)
                    Y1c=ep_1c+matmul(XX,beta_cT(:,t))+alpha_1c
                    CALL SGESV(NN,1,S1,NN,IPIV,Y1c,NN,INFO)

                    XX(i,16:30)=matmul(w_old(i,:),X)
                    XX(i,31+DD:30+2*DD)=matmul(w_old(i,:),zz_1(:,1:DD))
                    h1=ep_1t+matmul(XX,beta_tT(:,t))+alpha_1t
                    CALL contraction(NN,h1,w_old,lambda_tT(t),Y2t)

                    w1=dot_product(w_new(i,:),w_new(j,:))
                    w2=dot_product(w_new(:,i),w_new(:,j))
                    w3=dot_product(w_new(i,:),w_new(:,j))
                    w4=dot_product(w_new(j,:),w_new(:,i))

                    q=psi(i,j)+2*gamma_T(7+DD,t)*w_new(j,i)+(2*gamma_T(8+DD,t)-gamma_T(9+DD,t))*(sum(w_new(i,:))-w_new(i,j)) &
                        &+3*gamma_T(9+DD,t)*(sum(w_new(i,:))-w_new(i,j))**2 &
                        &+2*gamma_T(10+DD,t)*(sum(w_new(:,j))-w_new(i,j))+gamma_T(11+DD,t)*(w1+w2+w3)+gamma_T(12+DD,t)*3*w4

                    pp_w(i,j)=q*(-1)**(1-w_new(i,j))+0.5*gamma_T(13+DD,t)*(dot_product(Y1t,Y1t)-dot_product(Y2t,Y2t)) &
                        & + 0.5*gamma_T(14+DD,t)*(dot_product(Y1c,Y1c)-dot_product(Y2c,Y2c))

                    !CALL random_number(rand)
                    IF (rand3(r)<=pp_w(i,j)) then
                        W_old(i,j)=W_new(i,j)
                        Y2c=Y1c
                    END IF
                    W_new(i,j)=W_old(i,j)
                    XX(i,16:30)=matmul(w_new(i,:),X)
                    XX(i,31+DD:30+2*DD)=matmul(w_new(i,:),zz_1(:,1:DD))
                END IF
                !    END DO
                !END DO
            END DO

            like_Y1c=-1*dot_product(ep_1c, ep_1c)/(2*sige_cT(g,t-1))
            like_Y2c=-1*dot_product(ep_2c, ep_2c)/(2*sige_cT(g,t-1))

            XX(:,1:15)=X
            XX(:,16:30)=matmul(W,X)
            XX(:,31:30+DD)=zz_1(:,1:DD)
            XX(:,31+DD:30+2*DD)=matmul(W,zz_1(:,1:DD))

            h1=ep_1t+matmul(XX,beta_tT(:,t))+alpha_1t
            h2=ep_2t+matmul(XX,beta_tT(:,t))+alpha_tT(g,t-1)

            CALL contraction(NN,h1,W,lambda_tT(t),Y1t)
            CALL contraction(NN,h2,W,lambda_tT(t),Y2t)

            XX(:,16:30)=matmul(w_new,X)
            XX(:,31+DD:30+2*DD)=matmul(w_new,zz_1(:,1:DD))
            h1=ep_1t+matmul(XX,beta_tT(:,t))+alpha_1t
            h2=ep_2t+matmul(XX,beta_tT(:,t))+alpha_tT(g,t-1)
            CALL contraction(NN,h2,w_new,lambda_tT(t),Y3t)
            CALL contraction(NN,h1,w_new,lambda_tT(t),Y4t)

            Y3c=matmul(XX,beta_cT(:,t))+alpha_cT(g,t-1)+ep_2c
            Y4c=matmul(XX,beta_cT(:,t))+alpha_1c       +ep_1c
            S3=eye(NN)-lambda_cT(t)*(W_new)
            S4=eye(NN)-lambda_cT(t)*(W_new)
            CALL SGESV(NN,1,S3,NN,IPIV,Y3c,NN,INFO)
            CALL SGESV(NN,1,S4,NN,IPIV,Y4c,NN,INFO)

            ep_1t=ep_1t-sige_ctT(g,t-1)/sige_cT(g,t-1)*ep_1c
            ep_2t=ep_2t-sige_ctT(g,t-1)/sige_cT(g,t-1)*ep_2c

            like_Y1t=-1*dot_product(ep_1t, ep_1t)/(2*(sige_tT(g,t-1)-sige_ctT(g,t-1)/sige_cT(g,t-1)*sige_ctT(g,t-1)))
            like_Y2t=-1*dot_product(ep_2t, ep_2t)/(2*(sige_tT(g,t-1)-sige_ctT(g,t-1)/sige_cT(g,t-1)*sige_ctT(g,t-1)))

            DO i=1,15
                X_bar(i)=sum(XX(:,i))/NN
            END DO
            DO i=1,DD
                X_bar(15+i)=sum(XX(:,30+i))/NN
            END DO


            alpha_temp1(1)=alpha_1t-dot_product(X_bar,delta_tT(:,t-1))
            alpha_temp1(2)=alpha_1c-dot_product(X_bar,delta_cT(:,t-1))

            alpha_temp2(1)=alpha_tT(g,t-1)-dot_product(X_bar,delta_tT(:,t-1))
            alpha_temp2(2)=alpha_cT(g,t-1)-dot_product(X_bar,delta_cT(:,t-1))

            pp=(like_Y1t-like_Y2t)+(like_Y1c-like_Y2c) &
                & +(alpha_temp2(1)*alpha_temp2(1)-alpha_temp1(1)*alpha_temp1(1))/(2*siga_tT(t-1)) &
                & +(alpha_temp2(2)*alpha_temp2(2)-alpha_temp1(2)*alpha_temp1(2))/(2*siga_cT(t-1)) &
                & + 0.5*gamma_T(13+DD,t)*(dot_product(Y1t,Y1t)+dot_product(Y3t,Y3t)-dot_product(Y2t,Y2t)-dot_product(Y4t,Y4t)) &
                & + 0.5*gamma_T(14+DD,t)*(dot_product(Y3c,Y3c)-dot_product(Y4c,Y4c))

            CALL random_number(rand)
            IF (log(rand)<=pp)  THEN
                alpha_tT(g,t)=alpha_1t
                alpha_cT(g,t)=alpha_1c
                acc_3(g)=acc_3(g)+1.0
            ELSE
                alpha_tT(g,t)=alpha_tT(g,t-1)
                alpha_cT(g,t)=alpha_cT(g,t-1)
            END IF
            acc_rate3(g,t)=acc_3(g)/t
            IF(acc_rate3(g,t)<=0.4) c_3(g)=c_3(g)/1.01
            IF(acc_rate3(g,t)>=0.6) c_3(g)=c_3(g)*1.01

            DEALLOCATE(w12,wt12,w22,wt22,S22)
            DEALLOCATE(yr_school,C1,C2,C3,W,Wt,Yc,Yt,X,XX,X_bar,ep_1t,ep_2t,ep_1c,ep_2c,Y1t,Y2t,Y1c,Y2c,Y3t,Y4t,Y3c,Y4c,Y1ts,Y2ts,Y1cs,Y2cs,Y3ts,Y4ts,Y3cs,Y4cs,h1,h2,psi,S1,S2,S3,S4,IPIV,w_old,w_new,wt_old,wt_new,pp_w,zz_1,rand1,rand2,rand3)

        END DO
        !$omp end parallel

        !*** THE SAMPLING OF DELTA_C FROM PROSTERIOR DISTRIBUTION ***!

        delta_temp=0.0
        XVX=0.0
        XVY=0.0
        DO g = 1,GG
            NN=N(g)
            ALLOCATE(X(NN,15))
            ALLOCATE(zz_1(NN,DD))
            ALLOCATE(XX_bar(15+DD,1))
            ALLOCATE(IPIV(NN))

            X=group(1:NN,1:15,g)
            zz_1=zz(1:NN,1:DD,g)
            DO i=1,15
                XX_bar(i,1)=sum(X(:,i))/NN
            END DO
            DO i=1,DD
                XX_bar(15+i,1)=sum(zz_1(:,i))/NN
            ENDDO

            XVX=XVX+matmul(XX_bar,transpose(XX_bar))/siga_cT(t-1)
            XVY=XVY+XX_bar(1:15+DD,1)*alpha_cT(g,t)/siga_cT(t-1)

            DEALLOCATE(X,zz_1,XX_bar,IPIV)

        END DO
        CALL FINDInv(XVX+INV_D_0,INV_D,15+DD,ier)
        INV_D2=INV_D
        CALL spotrf('U',15+DD, INV_D2, 15+DD, info)
        errcode=vsrnggaussianmv(method_gaussian, stream_gaussian, 1, delta_temp, 15+DD, me, delta_0,  INV_D2)
        delta_cT(:,t)=delta_temp+matmul(INV_D,XVY)

        !*** THE SAMPLING OF DELTA_T FROM PROSTERIOR DISTRIBUTION ***!

        delta_temp=0.0
        XVX=0.0
        XVY=0.0
        DO g = 1,GG
            NN=N(g)
            ALLOCATE(X(NN,15))
            ALLOCATE(zz_1(NN,DD))
            ALLOCATE(XX_bar(15+DD,1))
            ALLOCATE(IPIV(NN))

            X=group(1:NN,1:15,g)
            zz_1=zz(1:NN,1:DD,g)
            DO i=1,15
                XX_bar(i,1)=sum(X(:,i))/NN
            END DO
            DO i=1,DD
                XX_bar(15+i,1)=sum(zz_1(:,i))/NN
            ENDDO

            XVX=XVX+matmul(XX_bar,transpose(XX_bar))/siga_tT(t-1)
            XVY=XVY+XX_bar(1:15+DD,1)*alpha_tT(g,t)/siga_tT(t-1)

            DEALLOCATE(X,zz_1,XX_bar,IPIV)
        END DO
        CALL FINDInv(XVX+INV_D_0,INV_D,15+DD,ier)
        INV_D2=INV_D
        CALL spotrf('U',15+DD, INV_D2, 15+DD, info)
        errcode=vsrnggaussianmv(method_gaussian, stream_gaussian, 1, delta_temp, 15+DD, me, delta_0,  INV_D2)
        delta_tT(:,t)=delta_temp+matmul(INV_D,XVY)

        !*** THE SAMPLING OF SIGMA_ALPHA FROM PROSTERIOR DISTRIBUTION ***!

        siga_cT(t)=(dot_product(alpha_cT(:,t),alpha_cT(:,t))+eta_0)/random_chisq(GG+rho_0, first)
        siga_tT(t)=(dot_product(alpha_tT(:,t),alpha_tT(:,t))+eta_0)/random_chisq(GG+rho_0, first)



        !******************GIBBS STEP FOR SIGMA  *****************!

        DO g=1,GG
            ALLOCATE(zero(3))
            zero=0.0
            DO
                COV_sigma_1=EYE(3)*c_5(g)
                call spotrf('U',3, COV_sigma_1, 3, info)
                errcode=vsrnggaussianmv(method_gaussian,stream_gaussian,1,sigma_1, 3, me, zero, COV_sigma_1)
                sigma_1=sigma_1+(/sige_cT(g,t-1), sige_tT(g,t-1), sige_ctT(g,t-1)/)
                !IF (t>300) THEN
                !    sigma_2=(/ random_normal()*sqrt(var(sige_cT(g,1:t-1),t-1))*2.38+sige_cT(g,t-1), &
                !    & random_normal()*sqrt(var(sige_tT(g,1:t-1),t-1))*2.38+sige_tT(g,t-1), &
                !    & random_normal()*sqrt(var(sige_ctT(g,1:t-1),t-1))*2.38+sige_ctT(g,t-1)/)
                !    sigma_1=0.95*sigma_2+0.05*sigma_1
                !END IF
                IF( (sigma_1(1)*sigma_1(2)>=sigma_1(3)*sigma_1(3)) .and. (sigma_1(1)>=0) .and. (sigma_1(2)>=0)) EXIT
            END DO
            DEALLOCATE(zero)

            NN=N(g)
            ALLOCATE(W(NN,NN));    ALLOCATE(Wt(NN,NN))
            ALLOCATE(Yc(NN));      ALLOCATE(Yt(NN));
            ALLOCATE(X(NN,15));    ALLOCATE(XX(NN,30+2*DD))
            ALLOCATE(ep_1t(NN));   ALLOCATE(ep_2t(NN));
            ALLOCATE(ep_1c(NN));   ALLOCATE(ep_2c(NN));
            ALLOCATE(S1(NN,NN));   ALLOCATE(S2(NN,NN));
            ALLOCATE(zz_1(NN,DD))


            W=network(1:NN,1:NN,g)
            Wt=transpose(W)
            Yt=Yt_latent(1:NN,g)
            Yc=Yc_latent(1:NN,g)
            X=group(1:NN,1:15,g)
            zz_1=zz(1:NN,1:DD,g)
            XX(:,1:15)=X
            XX(:,16:30)=matmul(W,X)
            XX(:,31:30+DD)=zz_1(:,1:DD)
            XX(:,31+DD:30+2*DD)=matmul(W,zz_1(:,1:DD))

            ALLOCATE(w12(censor(g),NN-censor(g)))
            ALLOCATE(w22(NN-censor(g),NN-censor(g)))
            ALLOCATE(wt12(censor(g),NN-censor(g)))
            ALLOCATE(wt22(NN-censor(g),NN-censor(g)))
            ALLOCATE(S22(NN-censor(g),NN-censor(g)))
            w12=W(1:censor(g),censor(g)+1:NN)
            w22=W(censor(g)+1:NN,censor(g)+1:NN)
            wt12=Wt(1:censor(g),censor(g)+1:NN)
            wt22=Wt(censor(g)+1:NN,censor(g)+1:NN)
            S22=eye(NN-censor(g))-lambda_tT(t)*(W22)

            !! Define Epsilon !!

            ep_1t(1:censor(g))=Yt(1:censor(g))-(lambda_tT(t)*matmul(W12,Yt(censor(g)+1:NN))+matmul(XX(1:censor(g),:),beta_tT(:,t))+alpha_tT(g,t))
            ep_1t(censor(g)+1:NN)=matmul(S22,Yt(censor(g)+1:NN))-matmul(XX(censor(g)+1:NN,:),beta_tT(:,t))-alpha_tT(g,t)
            ep_2t=ep_1t

            S1=eye(NN)-(W)*lambda_cT(t)
            ep_1c=matmul(S1,Yc)-matmul(XX,beta_cT(:,t))-alpha_cT(g,t)
            ep_2c=ep_1c

            det_1=(-NN/2)*log(sigma_1(1))
            det_2=(-NN/2)*log(sige_cT(g,t-1))
            like_Y1c=det_1-dot_product(ep_1c, ep_1c)/(2*sigma_1(1))
            like_Y2c=det_2-dot_product(ep_2c, ep_2c)/(2*sige_cT(g,t-1))


            ep_1t=ep_1t-sigma_1(3)/sigma_1(1)*ep_1c
            ep_2t=ep_2t-sige_ctT(g,t-1)/sige_cT(g,t-1)*ep_2c

            det_1=(-NN/2)*log(sigma_1(2)-sigma_1(3)/sigma_1(1)*sigma_1(3))
            det_2=(-NN/2)*log(sige_tT(g,t-1)-sige_ctT(g,t-1)/sige_cT(g,t-1)*sige_ctT(g,t-1))
            like_Y1t=det_1-dot_product(ep_1t, ep_1t)/(2*(sigma_1(2)-sigma_1(3)/sigma_1(1)*sigma_1(3)))
            like_Y2t=det_2-dot_product(ep_2t, ep_2t)/(2*(sige_tT(g,t-1)-sige_ctT(g,t-1)/sige_cT(g,t-1)*sige_ctT(g,t-1)))

            pp=(like_Y1t-like_Y2t)+(like_Y1c-like_Y2c)+logmvnpdf(sigma_1-sigma_0, Sig_0,3)-logmvnpdf((/sige_cT(g,t-1), sige_tT(g,t-1), sige_ctT(g,t-1)/)-sigma_0, Sig_0, 3)

            CALL random_number(rand)
            IF (log(rand)<=pp) THEN
                sige_cT(g,t)=sigma_1(1)
                sige_tT(g,t)=sigma_1(2)
                sige_ctT(g,t)=sigma_1(3)
                acc_5(g)=acc_5(g)+1.0
            ELSE
                sige_cT(g,t)=sige_cT(g,t-1)
                sige_tT(g,t)=sige_tT(g,t-1)
                sige_ctT(g,t)=sige_ctT(g,t-1)
            ENDIF
            acc_rate5(g,t)=acc_5(g)/t
            !IF(acc_rate5(g,t)<=0.2) c_5(g)=c_5(g)/1.01
            !IF(acc_rate5(g,t)>=0.4) c_5(g)=c_5(g)*1.01

            DEALLOCATE(w12,wt12,w22,wt22,S22)
            DEALLOCATE(W,Wt,Yc,Yt,X,XX,ep_1t,ep_2t,ep_1c,ep_2c,S1,S2,zz_1)
        END DO


        call system_clock ( clock_stop, clock_rate, clock_max )
        t_round=t/5
        IF (t-t_round*5==0) THEN
            WRITE(*,*)   'T=', t
            WRITE(*,10) 'Time:', real ( clock_stop - clock_start ) / real ( clock_rate )
            WRITE(*,30) 'GAMMA:', gamma_T(1:7,t)
            WRITE(*,30) 'GAMMA:', gamma_T(8:14+DD,t)
            WRITE(*,10) 'LAMBDA_T:', lambda_tT(t)
            WRITE(*,10) 'LAMBDA_C:', lambda_cT(t)
            WRITE(*,30) 'BETA_C:', beta_cT(1:8,t)
            WRITE(*,30) 'BETA_C:', beta_cT(9:15,t)
            WRITE(*,30) 'BETA_T:', beta_tT(1:8,t)
            WRITE(*,30) 'BETA_T:', beta_tT(9:15,t)
            WRITE(*,30) 'sige_c:',  sige_cT(1,t), sige_cT(11,t)
            WRITE(*,30) 'sige_t:',  sige_tT(1,t), sige_tT(11,t)
            WRITE(*,30) 'sige_ct:',  sige_ctT(1,t), sige_ctT(11,t)
            WRITE(*,30) 'siga_c:',  siga_cT(t)
            WRITE(*,30) 'siga_t:',  siga_tT(t)
            WRITE(*,10) 'acc_1:',  acc_rate1(t)
            WRITE(*,10) 'acc_2:',  acc_rate2(t)
            WRITE(*,60) 'acc_4:',  acc_rate4(1,t), acc_rate4(11,t)
            WRITE(*,60) 'acc_5:',  acc_rate5(1,t), acc_rate5(11,t)
            WRITE(*,10) 'acc_6:',  acc_rate6(t)
            WRITE(*,60) 'c_4',     c_4(1),c_4(11)
            WRITE(*,50) 'zz',      zz(1:5,1,1)


        END IF
        WRITE(1000,'(14f10.4)')  gamma_T(:,t)
        WRITE(2000,'(f10.4)')    lambda_cT(t)
        WRITE(3000,'(f10.4)')    lambda_tT(t)
        WRITE(4000,'(30f10.4)')  beta_cT(:,t)
        WRITE(5000,'(30f10.4)')  beta_tT(:,t)
        WRITE(4500,'(15f10.4)')  delta_cT(:,t)
        WRITE(5500,'(15f10.4)')  delta_tT(:,t)
        WRITE(6000,'(37f10.4)')  sige_cT(:,t)
        WRITE(7000,'(37f10.4)')  sige_tT(:,t)
        WRITE(8000,'(37f10.4)')  sige_ctT(:,t)
        WRITE(9000,'(37f10.4)')  alpha_cT(:,t)
        WRITE(10000,'(37f10.4)') alpha_tT(:,t)
        WRITE(11000,'(f10.4)') siga_cT(t)
        WRITE(12000,'(f10.4)') siga_tT(t)
        OPEN (60000, file = trim(adjustl(path1))  // trim(adjustl(path3))  // 'latent_Y.txt', status='REPLACE')
        WRITE(60000,'(50f9.4)') ((Yt_latent(p1,p2),p1=1,MAX),p2=1,GG)
        CLOSE(60000)

    END DO


    close(1000)
    close(2000)
    close(3000)
    close(4000)
    close(5000)
    close(6000)
    close(7000)
    close(8000)
    close(9000)
    close(10000)

10  format(a8,f7.4)
30  format(a8,10f10.4)
40  format(a8,6f7.4)
50  format(a8,5f7.4)
60  format(a8,2f7.4)
70  format(30f7.4)

    end program estimation

    SUBROUTINE contraction(NN,ep,W,lambda,Y)
    IMPLICIT NONE
    INTEGER:: NN
    REAL , INTENT(IN)  :: lambda, ep(:),  W(:,:)
    REAL, INTENT(OUT)  :: Y(:)

    ! local variable !
    REAL, ALLOCATABLE :: Y1(:), Y2(:), temp_Y(:,:)
    REAL :: diff
    INTEGER:: count

    ALLOCATE(Y1(NN))
    ALLOCATE(Y2(NN))
    ALLOCATE(temp_Y(NN,2))

    Y1=ep
    diff=1.0
    count=0
    Do
        temp_Y(:,1)=lambda*matmul(W,Y1)+ep
        temp_Y(:,2)=0.0
        Y2=maxval(temp_Y,dim=2)
        diff=maxval(abs(Y2-Y1))
        if (diff<=1e-6) exit
        Y1=Y2
        count=count+1
        if (count>=200) then
            !print*, 'convergence fail'
            exit
        endif
    End do
    Y=Y2

    DEALLOCATE(Y1)
    DEALLOCATE(Y2)
    DEALLOCATE(temp_Y)
    END SUBROUTINE contraction