    include 'mkl_vsl.f90'

    program estimation

    USE random
    USE TOOL
    USE lapack95
    USE MKL_VSL_TYPE
    USE MKL_VSL
    USE omp_lib
    IMPLICIT NONE

    !******************* GENERAL VARIABLES ****************!


    CHARACTER(100)      :: path1='/home/cshsieh/research/2020_exponential_network_formation/simulation/continuous/'
    CHARACTER(100)      :: path2='/data/data_30_30/'
    CHARACTER(100)      :: path3='/result/no_latent/'
    CHARACTER(40)       :: numchr
    INTEGER, PARAMETER  :: GG=30, TT=50000, MAX=30, RR=1, Nthreads=20, DD=1, LL=100
    REAL                :: c_1, c_2, acc_1, acc_2, c_3(GG), acc_3(GG), c_0(GG), acc_0(GG), c_4(GG), acc_4(GG), acc_4v, c_5, acc_5, kk
    INTEGER             :: N(GG), NN, missing(GG), flag(GG)
    INTEGER             :: brng, method, me, i, j, g, t, ier, k,  d, r, l, seedsize, seed(2), errorflag, INFO, seed_mkl, t_round
    INTEGER             :: clock_max, clock_rate, clock_start, clock_stop, ithread, iblock,ibegin,iend
    REAL                :: C_raw(MAX,MAX,GG), W_raw(MAX,MAX,GG), X_raw(MAX,GG), Y_raw(MAX,GG), Z_raw(MAX,GG), alpha(GG)
    REAL, ALLOCATABLE   :: C(:,:), W(:,:), Wt(:,:), overage(:), IPIV(:)
    REAL, ALLOCATABLE   :: Y(:), Ys(:), Yss(:), X(:), XX(:,:)
    LOGICAL, PARAMETER  :: first=.true.
    TYPE (VSL_STREAM_STATE) :: stream
    INTEGER             ::  errcode

    !*** hyperparameters in the prior distribution ***!
    REAL, DIMENSION(9)      :: gamma_0
    REAL, DIMENSION(9,9)    :: G_0
    REAL, DIMENSION(2)      :: beta_0
    REAL, DIMENSION(2,2)    :: B_0, B_1, INV_B_0
    REAL                    :: eta_0, A_0
    INTEGER                 :: rho_0

    !*** posterior draws of parameters *******!

    REAL, DIMENSION(9,TT)   :: gamma_T
    REAL, DIMENSION(TT)     :: lambda_T, siga_T, acc_rate1, acc_rate2, acc_rate5
    REAL, DIMENSION(2, TT)  :: beta_T
    REAL, DIMENSION(GG,TT)  :: sige_T, alpha_T, acc_rate0, acc_rate3, acc_rate4


    !********VARIABLE IN M-H FOR GAMMA  & DELTA ***************!

    REAL ::  gamma_1(9), cov_gamma_1(9,9), gamma_2(9)
    REAL, ALLOCATABLE:: psi(:,:), psi_1(:,:), psi_2(:,:), ep(:), S(:,:), zero(:)
    REAL(KIND=8) ::  q_1, q_2, q_g1(GG), pp_g
    INTEGER ::  CODE

    !********VARIABLE IN M-H FOR  LAMBDA  ***************!

    REAL :: lambda_1, lambda_2
    REAL, ALLOCATABLE :: W_old(:,:), W_new(:,:), Wt_old(:,:), Wt_new(:,:), Y_old(:), Y_new(:)
    REAL :: w1, w2, w3, w4
    REAL, ALLOCATABLE :: S1(:,:), S2(:,:),  S3(:,:), S4(:,:)
    REAL, ALLOCATABLE :: ep_1(:), ep_2(:), ep_1v(:), ep_2v(:)
    REAL, ALLOCATABLE :: V(:,:), V1(:,:), V2(:,:)
    REAL, ALLOCATABLE :: Y1(:),Y2(:), Y1s(:), Y2s(:), f(:) , S_new(:,:)
    REAL(KIND=8), ALLOCATABLE ::  pp_w(:,:)
    REAL(KIND=8) :: like_Y1, like_Y2, pp_l(GG), q, rand, pp

    !*************VARIABLE IN M-H FOR BETA**************!

    REAL :: beta_1(2), beta_2(2)
    REAL :: XVX(2,2), XVY(2), INV_B(2,2), INV_B2(2,2), beta_temp(2)
    REAL, ALLOCATABLE ::  XX2(:,:), YY(:)

    !*************VARIABLE IN GIBBS FOR SIGMA_E & SIGMA_EZ & ALPHA_G**************!

    REAL:: alpha_1, alpha_2
    INTEGER :: rho_1, stack


    seedsize=2
    seed(1)=12345
    seed(2)=54321
    CALL RANDOM_SEED
    CALL RANDOM_SEED(SIZE=seedsize)
    CALL RANDOM_SEED(PUT=seed)

    seed_mkl=12345
    brng=VSL_BRNG_MCG31
    method=VSL_RNG_METHOD_GAUSSIANMV_BOXMULLER
    me=VSL_MATRIX_STORAGE_FULL



    DO l=1, LL

        WRITE(numchr,*) l

        seed_mkl=seed_mkl+l
        errcode=vslnewstream(stream,brng,seed_mkl)


        CALL networksize(GG, MAX, path1, path2, N)
        CALL define_variable(C_raw, X_raw, W_raw, Y_raw, Z_raw, alpha, GG, l, N, path1, path2, MAX)

        beta_0=0.0
        gamma_0=0.0
        eta_0=0.1
        rho_0=2
        B_0=EYE(2)*10.0
        CALL FINDInv(B_0,INV_B_0,2,ier)
        A_0=400.0
        G_0=EYE(9)*10.0


        gamma_T(:,1)=(/-2.0, 0.3, 0.3, 0.2, -0.1, 0.03, 0.30, -0.20, 0.3 /)
        beta_T(:,1)=(/ 0.3, 0.1 /)
        lambda_T(1)=0.0700
        sige_T(:,1)=0.500
        alpha_T(:,1)=0.5


        c_1=1e-5
        c_2=1e-4
        c_3=2.0
        c_4=0.05
        acc_2=0.0;acc_3=0.0
        acc_4=0.0;acc_5=0.0
        acc_rate0=0.0;acc_rate1=0.0
        acc_rate2=0.0;acc_rate3=0.0
        acc_rate4=0.0;acc_rate5=0.0


        OPEN (1000, file =  trim(adjustl(path1)) // trim(adjustl(path3)) //  'R' // trim(adjustl(numchr))   // '/gamma.txt', status='unknown')
        OPEN (2000, file =  trim(adjustl(path1)) // trim(adjustl(path3)) //  'R' // trim(adjustl(numchr))   // '/lambda.txt', status='unknown')
        OPEN (3000, file =  trim(adjustl(path1)) // trim(adjustl(path3)) //  'R' // trim(adjustl(numchr))   // '/beta.txt', status='unknown')
        OPEN (4000, file =  trim(adjustl(path1)) // trim(adjustl(path3)) //  'R' // trim(adjustl(numchr))   // '/sigma.txt', status='unknown')
        OPEN (5000, file =  trim(adjustl(path1)) // trim(adjustl(path3)) //  'R' // trim(adjustl(numchr))   // '/alpha.txt', status='unknown')


        DO t=2, TT
            call system_clock ( clock_start, clock_rate, clock_max )

            !**********************************************************!


            cov_gamma_1=eye(9)*c_1
            call spotrf('U',9, cov_gamma_1,9,info)
            errcode=vsrnggaussianmv(method,stream,1,gamma_1,9,me,gamma_0, cov_gamma_1)
            gamma_1=gamma_1+gamma_T(:,t-1)
            lambda_1=lambda_T(t-1)+random_normal()*sqrt(c_1)

            IF (t>1000) THEN
                COV_gamma_1=cov(gamma_T(:,500:t-1),9,t-500)*2.38**2/(9)
                call spotrf('U',9, COV_gamma_1, 9, info)
                errcode=vsrnggaussianmv(method,stream,1,gamma_2, 9, me, gamma_0, COV_gamma_1)
                gamma_2=gamma_2+gamma_T(:,t-1)
                gamma_1=0.8*gamma_2+0.2*gamma_1

                lambda_2=random_normal()*sqrt(var(lambda_T(1:t-1),t-1))*2.38+lambda_T(t-1)
                lambda_1=0.8*lambda_2+0.2*lambda_1

            END IF

            gamma_2=gamma_T(:,t-1)

            Call OMP_SET_NUM_THREADS(Nthreads)
            !$omp parallel default(shared) private(g,NN, S, W, Wt, ithread, iblock, ibegin, iend)
            ithread = OMP_GET_THREAD_NUM()
            iblock = (GG+Nthreads-1)/Nthreads
            ibegin = ithread*iblock+1
            iend = min((ithread+1)*iblock,GG)
            DO g = ibegin,iend
                NN=N(g)
                ALLOCATE(S(NN,NN))
                ALLOCATE(W(NN,NN))
                ALLOCATE(Wt(NN,NN))

                W=W_raw(1:NN,1:NN,g)
                Wt=transpose(W)

                S=eye(NN)-lambda_1*(W)
                IF (FindDet(S, NN)>0)  flag(g)=1
                DEALLOCATE(S,W,Wt)
            END DO
            !$omp end parallel


            q_g1=0.0
            pp_l=0.0

            Call OMP_SET_NUM_THREADS(Nthreads)

            !$omp parallel default(shared) private(g,NN,C,W,Wt,X,XX,Y,Ys,Yss,i,j,psi,pp_w,S, r, &
            !$omp & S1,S2,IPIV,INFO,w1,w2,w3,w4,q,rand,psi_1,psi_2,S3,S4,ep_1,ep_2, pp,  &
            !$omp & like_Y1,like_Y2,Y1,Y2,Y1s,Y2s,q_1,q_2, k, kk, W_old, W_new, Wt_old, Wt_new, &
            !$omp & acc_4v, zero, d, errcode, &
            !$omp & ithread, iblock, ibegin, iend)

            ithread = OMP_GET_THREAD_NUM()
            iblock = (GG+Nthreads-1)/Nthreads
            ibegin = ithread*iblock+1
            iend = min((ithread+1)*iblock,GG)

            DO g = ibegin,iend
                NN=N(g)
                ALLOCATE(C(NN,NN));
                ALLOCATE(W(NN,NN));         ALLOCATE(Wt(NN,NN))
                ALLOCATE(Y(NN))
                ALLOCATE(Ys(NN));           ALLOCATE(Yss(NN))
                ALLOCATE(X(NN));            ALLOCATE(XX(NN,2))
                ALLOCATE(psi(NN,NN))
                ALLOCATE(S(NN,NN));
                ALLOCATE(W_old(NN,NN));     ALLOCATE(W_new(NN,NN))
                ALLOCATE(Wt_old(NN,NN));    ALLOCATE(Wt_new(NN,NN))
                ALLOCATE(S1(NN,NN));        ALLOCATE(S2(NN,NN))
                ALLOCATE(S3(NN,NN));        ALLOCATE(S4(NN,NN))
                ALLOCATE(Y1(NN));           ALLOCATE(Y2(NN))
                ALLOCATE(Y1s(NN));          ALLOCATE(Y2s(NN))
                ALLOCATE(pp_w(NN,NN));
                ALLOCATE(psi_1(NN,NN));     ALLOCATE(psi_2(NN,NN))
                ALLOCATE(ep_1(NN));         ALLOCATE(ep_2(NN))
                ALLOCATE(IPIV(NN))

                C=C_raw(1:NN,1:NN,g)
                W=W_raw(1:NN,1:NN,g)
                Y=Y_raw(1:NN,g)
                X=X_raw(1:NN,g)
                Wt=transpose(W)

                DO i=1, NN
                    DO j=1, NN
                        psi(i,j)=gamma_1(1)+gamma_1(2)*C(i,j)
                    END DO
                END DO

                !*************************************!
                ! DMH step to update lambda and gamma !
                !*************************************!


                S=eye(NN)-(W)*lambda_1

                XX(:,1)=X
                XX(:,2)=matmul(W,X)

                ep_1=matmul(S,Y)-matmul(XX,beta_T(:,t-1))-alpha_T(g,t-1)

                Y2=Y
                W_old=W
                W_new=W
                DO r=1, RR
                    DO i=1, NN
                        DO j=1, NN
                            IF (j /= i) THEN
                                W_new(i,j)=1-W_new(i,j)
                                S1=eye(NN)-(W_new)*lambda_1
                                XX(:,2)=matmul(w_new,X)
                                Y1=ep_1+matmul(XX,beta_T(:,t-1))+alpha_T(g,t-1)
                                CALL SGESV(NN,1,S1,NN,IPIV,Y1,NN,INFO)

                                w1=dot_product(w_new(i,:),w_new(j,:))
                                w2=dot_product(w_new(:,i),w_new(:,j))
                                w3=dot_product(w_new(i,:),w_new(:,j))
                                w4=dot_product(w_new(j,:),w_new(:,i))

                                q=psi(i,j)+2*gamma_1(3)*w_new(j,i)+(2*gamma_1(4)-gamma_1(5))*(sum(w_new(i,:))-w_new(i,j)) &
                                    &+3*gamma_1(5)*(sum(w_new(i,:))-w_new(i,j))**2 &
                                    &+2*gamma_1(6)*(sum(w_new(:,j))-w_new(i,j)) +gamma_1(7)*(w1+w2+w3)+gamma_1(8)*3*w4


                                pp_w(i,j)=q*(-1)**(1-w_new(i,j))+0.5*gamma_1(9)*(dot_product(Y1,Y1)-dot_product(Y2,Y2))

                                CALL random_number(rand)
                                IF (log(rand)<=pp_w(i,j)) then
                                    W_old(i,j)=W_new(i,j)
                                    Y2=Y1
                                END IF
                                W_new(i,j)=W_old(i,j)
                                XX(:,2)=matmul(w_new,X)
                            END IF
                        END DO
                    END DO
                END DO

                psi_1=0.0
                psi_2=0.0
                DO i=1, NN
                    DO j=1, NN
                        IF (j /= i) THEN
                            psi_1(i,j)=gamma_1(1)+gamma_1(2)*C(i,j)
                            psi_2(i,j)=gamma_2(1)+gamma_2(2)*C(i,j)
                        END IF
                    END DO
                END DO

                S1=eye(NN)-lambda_1*(W)
                S2=eye(NN)-lambda_T(t-1)*(W)

                XX(:,2)=matmul(W,X)
                ep_1=matmul(S1,Y)-matmul(XX,beta_T(:,t-1))-alpha_T(g,t-1)
                ep_2=matmul(S2,Y)-matmul(XX,beta_T(:,t-1))-alpha_T(g,t-1)

                like_Y1=log(FindDet(S1, NN))-dot_product(ep_1, ep_1)/(2*sige_T(g,t-1))
                like_Y2=log(FindDet(S2, NN))-dot_product(ep_2, ep_2)/(2*sige_T(g,t-1))

                XX(:,2)=matmul(w_new,X)
                Y1=matmul(XX,beta_T(:,t-1))+alpha_T(g,t-1)+ep_2
                Y2=matmul(XX,beta_T(:,t-1))+alpha_T(g,t-1)+ep_1
                S3=eye(NN)-lambda_T(t-1)*(W_new)
                S4=eye(NN)-lambda_1*(W_new)
                CALL SGESV(NN,1,S3,NN,IPIV,Y1,NN,INFO)
                CALL SGESV(NN,1,S4,NN,IPIV,Y2,NN,INFO)

                
                q_1= 0.5*gamma_1(9)*dot_product(Y,Y)-0.5*gamma_2(9)*dot_product(Y,Y) &
                    &+trace(matmul(psi_1,transpose(W)),NN)- trace(matmul(psi_2,transpose(W)),NN) &
                    &+(gamma_1(3)-gamma_2(3))*trace(matmul(W,W),NN)&
                    &+(gamma_1(4)-gamma_2(4))*(sum(matmul(W,ones(NN,1))*matmul(W,ones(NN,1)))-sum( matmul(W,ones(NN,1)))) &
                    &+(gamma_1(5)-gamma_2(5))*(sum(matmul(W,ones(NN,1))*(matmul(W,ones(NN,1))*matmul(W,ones(NN,1))))&
                    &-2*sum(matmul(W,ones(NN,1))*matmul(W,ones(NN,1)))+sum( matmul(W,ones(NN,1))))&
                    &+(gamma_1(6)-gamma_2(6))*(sum(matmul(ones(1,NN),W)*matmul(ones(1,NN),W))-sum( matmul(W,ones(NN,1)))) &
                    &+(gamma_1(7)-gamma_2(7))*trace( matmul(matmul(W,W),transpose(W)),NN) &
                    &+(gamma_1(8)-gamma_2(8))*trace( matmul(matmul(W,W),W),NN) &
                    &+0.5*gamma_2(9)*dot_product(Y1,Y1)-0.5*gamma_1(9)*dot_product(Y2,Y2) &
                    &+trace(matmul(psi_2,transpose(w_new)),NN)-trace(matmul(psi_1,transpose(w_new)),NN)  &
                    &+(gamma_2(3)-gamma_1(3))*trace(matmul(w_new,w_new),NN)&
                    &+(gamma_2(4)-gamma_1(4))*(sum(matmul(w_new,ones(NN,1))*matmul(w_new,ones(NN,1)))-sum(matmul(w_new,ones(NN,1)))) &
                    &+(gamma_2(5)-gamma_1(5))*(sum(matmul(w_new,ones(NN,1))*(matmul(w_new,ones(NN,1))*matmul(w_new,ones(NN,1))))&
                    &-2*sum(matmul(w_new,ones(NN,1))*matmul(w_new,ones(NN,1)))+sum(matmul(w_new,ones(NN,1))))&
                    &+(gamma_2(6)-gamma_1(6))*(sum(matmul(ones(1,NN),w_new)*matmul(ones(1,NN),w_new))-sum(matmul(w_new,ones(NN,1)))) &
                    &+(gamma_2(7)-gamma_1(7))*trace( matmul(matmul(w_new,w_new),transpose(w_new)),NN) &
                    &+(gamma_2(8)-gamma_1(8))*trace( matmul(matmul(w_new,w_new),w_new),NN)

                q_g1(g)=q_1
                pp_l(g)=(like_Y1-like_Y2)

                DEALLOCATE(C,W,Wt,Y,Ys,Yss,X,XX,psi,S,W_old,W_new,Wt_old,Wt_new,S1,S2,S3,S4,Y1,Y2,Y1s,Y2s,pp_w,psi_1,psi_2,ep_1,ep_2,IPIV)
            END DO
            !$omp end parallel

            pp_g=sum(pp_l)+sum(q_g1)+logmvnpdf(gamma_1, G_0, 9)-logmvnpdf(gamma_2, G_0, 9)
            CALL random_number(rand)
            IF (log(rand)<=pp_g)  THEN
                gamma_T(:,t)=gamma_1
                lambda_T(t)=lambda_1
                acc_1=acc_1+1.0
            ELSE
                gamma_T(:,t)=gamma_T(:,t-1)
                lambda_T(t)=lambda_T(t-1)
            END IF
            acc_rate1(t)=acc_1/t


            !*****************************************************************!

            B_1=eye(2)*c_2
            call spotrf('U',2, B_1,2,info)
            errcode=vsrnggaussianmv(method,stream,1,beta_1,2,me,beta_0, B_1)
            beta_1=beta_1+beta_T(:,t-1)

            IF (t>500) THEN
                B_1=cov(beta_T(:,1:t-1),2,t-1)*2.38**2/(2)
                call spotrf('U',2, B_1, 2, info)
                errcode=vsrnggaussianmv(method,stream,1, beta_2, 2, me, beta_0, B_1)
                beta_2=beta_2+beta_T(:,t-1)
                beta_1=0.95*beta_2+0.05*beta_1
            END IF

            pp_l=0.0


            Call OMP_SET_NUM_THREADS(Nthreads)

            !$omp parallel default(shared) private(g,NN,C,W,Wt,X,XX,Y,i,j,psi,pp_w,S,w_old,w_new,r, &
            !$omp & S1,S2,IPIV,INFO,w1,w2,w3,w4,q,rand,S3,S4,ep_1,ep_2,Wt_new, Wt_old, &
            !$omp & like_Y1,like_Y2,Y1,Y2,Y1s,Y2s,q_1,q_2, &
            !$omp & ithread, iblock, ibegin, iend)

            ithread = OMP_GET_THREAD_NUM()
            iblock = (GG+Nthreads-1)/Nthreads
            ibegin = ithread*iblock+1
            iend = min((ithread+1)*iblock,GG)

            DO g = ibegin,iend
                NN=N(g)
                ALLOCATE(C(NN,NN));
                ALLOCATE(W(NN,NN));         ALLOCATE(Wt(NN,NN))
                ALLOCATE(Y(NN))
                ALLOCATE(X(NN));            ALLOCATE(XX(NN,2))
                ALLOCATE(psi(NN,NN))
                ALLOCATE(S(NN,NN));
                ALLOCATE(W_old(NN,NN));     ALLOCATE(W_new(NN,NN))
                ALLOCATE(Wt_old(NN,NN));    ALLOCATE(Wt_new(NN,NN))
                ALLOCATE(S1(NN,NN));        ALLOCATE(S2(NN,NN))
                ALLOCATE(Y1(NN));           ALLOCATE(Y2(NN))
                ALLOCATE(Y1s(NN));          ALLOCATE(Y2s(NN))
                ALLOCATE(pp_w(NN,NN));
                ALLOCATE(S3(NN,NN));        ALLOCATE(S4(NN,NN))
                ALLOCATE(ep_1(NN));         ALLOCATE(ep_2(NN))
                ALLOCATE(IPIV(NN))

                C=C_raw(1:NN,1:NN,g)
                W=W_raw(1:NN,1:NN,g)
                Y=Y_raw(1:NN,g)
                X=X_raw(1:NN,g)
                Wt=transpose(W)

                XX(:,1)=X
                XX(:,2)=matmul(W,X)

                psi=0.0
                DO i=1, NN
                    DO j=1, NN
                        IF (DD==1) THEN
                            psi(i,j)=gamma_T(1,t)+gamma_T(2,t)*C(i,j)
                        ELSEIF (DD==2) THEN
                            psi(i,j)=gamma_T(1,t)+gamma_T(2,t)*C(i,j)
                        ELSEIF (DD==3) THEN
                            psi(i,j)=gamma_T(1,t)+gamma_T(2,t)*C(i,j)
                        ENDIF
                    END DO
                END DO

                S=eye(NN)-lambda_T(t)*(W)
                ep_1=matmul(S,Y)-matmul(XX,beta_1)-alpha_T(g,t-1)

                Y2=Y
                W_old=W
                W_new=W
                DO r=1, RR
                    DO i=1, NN
                        DO j=1, NN
                            IF (j /= i) THEN
                                W_new(i,j)=1-W_new(i,j)
                                S1=eye(NN)-(W_new)*lambda_T(t)
                                XX(:,2)=matmul(w_new,X)
                                Y1=ep_1+matmul(XX,beta_1)+alpha_T(g,t-1)
                                CALL SGESV(NN,1,S1,NN,IPIV,Y1,NN,INFO)

                                w1=dot_product(w_new(i,:),w_new(j,:))
                                w2=dot_product(w_new(:,i),w_new(:,j))
                                w3=dot_product(w_new(i,:),w_new(:,j))
                                w4=dot_product(w_new(j,:),w_new(:,i))

                                q=psi(i,j)+2*gamma_T(3,t)*w_new(j,i)+(2*gamma_T(4,t)-gamma_T(5,t))*(sum(w_new(i,:))-w_new(i,j)) &
                                    &+3*gamma_T(5,t)*(sum(w_new(i,:))-w_new(i,j))**2 &
                                    &+2*gamma_T(6,t)*(sum(w_new(:,j))-w_new(i,j)) +gamma_T(7,t)*(w1+w2+w3)+gamma_T(8,t)*3*w4

                                pp_w(i,j)=q*(-1)**(1-w_new(i,j))+0.5*gamma_T(9,t)*(dot_product(Y1,Y1)-dot_product(Y2,Y2))

                                CALL random_number(rand)
                                IF (log(rand)<=pp_w(i,j)) then
                                    W_old(i,j)=W_new(i,j)
                                    Y2=Y1
                                END IF
                                W_new(i,j)=W_old(i,j)
                                XX(:,2)=matmul(w_new,X)
                            END IF
                        END DO
                    END DO
                END DO


                XX(:,2)=matmul(W,X)
                ep_1=matmul(S,Y)-matmul(XX,beta_1)-alpha_T(g,t-1)
                ep_2=matmul(S,Y)-matmul(XX,beta_T(:,t-1))-alpha_T(g,t-1)

                like_Y1=-dot_product(ep_1, ep_1)/(2*sige_T(g,t-1))
                like_Y2=-dot_product(ep_2, ep_2)/(2*sige_T(g,t-1))


                XX(:,2)=matmul(w_new,X)
                Y1=matmul(XX,beta_T(:,t-1))+alpha_T(g,t-1)+ep_2
                Y2=matmul(XX,beta_1)       +alpha_T(g,t-1)+ep_1
                S3=eye(NN)-lambda_T(t)*(W_new)
                S4=eye(NN)-lambda_T(t)*(W_new)
                CALL SGESV(NN,1,S3,NN,IPIV,Y1,NN,INFO)
                CALL SGESV(NN,1,S4,NN,IPIV,Y2,NN,INFO)

                pp_l(g)=(like_Y1-like_Y2)+0.5*gamma_T(9,t)*(dot_product(Y1,Y1)-dot_product(Y2,Y2))


                DEALLOCATE(C,W,Wt,Y,X,XX,psi,S,W_old,W_new,Wt_old,Wt_new,S1,S2,Y1,Y2,Y1s,Y2s,pp_w,S3,S4,ep_1,ep_2,IPIV)

            END DO
            !$omp end parallel

            pp_g=sum(pp_l)+logmvnpdf(beta_1, B_0, 2)-logmvnpdf(beta_T(:,t-1), B_0, 2)
            CALL random_number(rand)
            IF (log(rand)<=pp_g)  THEN
                beta_T(:,t)=beta_1
                acc_2=acc_2+1.0
            ELSE
                beta_T(:,t)=beta_T(:,t-1)
            END IF
            acc_rate2(t)=acc_2/t



            !******************GIBBS STEP FOR SIGMA_E  *****************!

            DO g=1,GG
                NN=N(G)
                ALLOCATE(W(NN,NN));         ALLOCATE(Wt(NN,NN));
                ALLOCATE(Y(NN))
                ALLOCATE(X(NN));            ALLOCATE(XX(NN,2))
                ALLOCATE(S(NN,NN));         ALLOCATE(ep(NN))

                W=W_raw(1:NN,1:NN,g)
                Y=Y_raw(1:NN,g)
                X=X_raw(1:NN,g)
                Wt=transpose(W)

                S=eye(NN)-lambda_T(t)*(W)
                XX(:,1)=X
                XX(:,2)=matmul(W,X)

                ep=matmul(S,Y)-matmul(XX,beta_T(:,t))-alpha_T(g,t-1)
                sige_T(g,t)=(dot_product(ep,ep)+eta_0)/random_chisq(NN+rho_0, first)
                DEALLOCATE(W,Wt,Y,X,XX,S,ep)
            END DO

            !*************GIBBS STEP FOR ALPHA_G*********************!

            Call OMP_SET_NUM_THREADS(Nthreads)

            !$omp parallel default(shared) private(g,NN,alpha_1,alpha_2,C,W,Wt,X,XX,Y,i,j,psi,pp_w,S,r,overage, &
            !$omp & S1,S2,IPIV,INFO,w1,w2,w3,w4,q,rand,psi_1,psi_2,S3,S4, ep_1,ep_2, &
            !$omp & like_Y1,like_Y2,Y1,Y2,Y1s,Y2s,q_1, pp, W_old,W_new, Wt_old,Wt_new, &
            !$omp & ithread, iblock, ibegin, iend)

            ithread = OMP_GET_THREAD_NUM()
            iblock = (GG+Nthreads-1)/Nthreads
            ibegin = ithread*iblock+1
            iend = min((ithread+1)*iblock,GG)

            DO g = ibegin,iend

                alpha_1=alpha_T(g,t-1)+random_normal()*sqrt(c_3(g))
                IF (t>300) THEN
                    alpha_2=random_normal()*sqrt(var(alpha_T(g,1:t-1),t-1))*2.38+alpha_T(g,t-1)
                    alpha_1=0.8*alpha_2+0.2*alpha_1
                END IF

                NN=N(g)
                ALLOCATE(C(NN,NN));
                ALLOCATE(W(NN,NN));         ALLOCATE(Wt(NN,NN))
                ALLOCATE(Y(NN))
                ALLOCATE(X(NN));            ALLOCATE(XX(NN,2))
                ALLOCATE(psi(NN,NN))
                ALLOCATE(S(NN,NN));
                ALLOCATE(W_old(NN,NN));     ALLOCATE(W_new(NN,NN))
                ALLOCATE(Wt_old(NN,NN));    ALLOCATE(Wt_new(NN,NN))
                ALLOCATE(S1(NN,NN));        ALLOCATE(S2(NN,NN))
                ALLOCATE(Y1(NN));           ALLOCATE(Y2(NN))
                ALLOCATE(Y1s(NN));          ALLOCATE(Y2s(NN))
                ALLOCATE(pp_w(NN,NN));      ALLOCATE(overage(NN))
                ALLOCATE(psi_1(NN,NN));     ALLOCATE(psi_2(NN,NN))
                ALLOCATE(S3(NN,NN));        ALLOCATE(S4(NN,NN))
                ALLOCATE(ep_1(NN));         ALLOCATE(ep_2(NN))
                ALLOCATE(IPIV(NN))

                C=C_raw(1:NN,1:NN,g)
                W=W_raw(1:NN,1:NN,g)
                Y=Y_raw(1:NN,g)
                X=X_raw(1:NN,g)
                Wt=transpose(W)

                XX(:,1)=X
                XX(:,2)=matmul(W,X)

                psi=0.0
                DO i=1, NN
                    DO j=1, NN
                        IF (DD==1) THEN
                            psi(i,j)=gamma_T(1,t)+gamma_T(2,t)*C(i,j)
                        ELSEIF (DD==2) THEN
                            psi(i,j)=gamma_T(1,t)+gamma_T(2,t)*C(i,j)
                        ELSEIF (DD==3) THEN
                            psi(i,j)=gamma_T(1,t)+gamma_T(2,t)*C(i,j)
                        ENDIF
                    END DO
                END DO

                S=eye(NN)-lambda_T(t)*(W)
                ep_1=matmul(S,Y)-matmul(XX,beta_T(:,t))-alpha_1

                Y2=Y
                W_old=W
                W_new=W
               
                DO r=1, RR
                    DO i=1, NN
                        DO j=1, NN
                            IF (j /= i) THEN
                                W_new(i,j)=1-W_new(i,j)
                                S1=eye(NN)-(W_new)*lambda_T(t)
                                XX(:,2)=matmul(w_new,X)
                                Y1=ep_1+matmul(XX,beta_T(:,t))+alpha_1
                                CALL SGESV(NN,1,S1,NN,IPIV,Y1,NN,INFO)

                                w1=dot_product(w_new(i,:),w_new(j,:))
                                w2=dot_product(w_new(:,i),w_new(:,j))
                                w3=dot_product(w_new(i,:),w_new(:,j))
                                w4=dot_product(w_new(j,:),w_new(:,i))

                                q=psi(i,j)+2*gamma_T(3,t)*w_new(j,i)+(2*gamma_T(4,t)-gamma_T(5,t))*(sum(w_new(i,:))-w_new(i,j)) &
                                    &+3*gamma_T(5,t)*(sum(w_new(i,:))-w_new(i,j))**2 &
                                    &+2*gamma_T(6,t)*(sum(w_new(:,j))-w_new(i,j)) +gamma_T(7,t)*(w1+w2+w3)+gamma_T(8,t)*3*w4

                                pp_w(i,j)=q*(-1)**(1-w_new(i,j))+0.5*gamma_T(9,t)*(dot_product(Y1,Y1)-dot_product(Y2,Y2))

                                CALL random_number(rand)
                                IF (log(rand)<=pp_w(i,j)) then
                                    W_old(i,j)=W_new(i,j)
                                    Y2=Y1
                                END IF
                                W_new(i,j)=W_old(i,j)
                                XX(:,2)=matmul(w_new,X)
                            END IF
                        END DO
                    END DO
                END DO


                S=eye(NN)-lambda_T(t)*(W)
                XX(:,1)=X
                XX(:,2)=matmul(W,X)

                ep_1=matmul(S,Y)-matmul(XX,beta_T(:,t))-alpha_1
                ep_2=matmul(S,Y)-matmul(XX,beta_T(:,t))-alpha_T(g,t-1)

                like_Y1=-dot_product(ep_1, ep_1)/(2*sige_T(g,t))
                like_Y2=-dot_product(ep_2, ep_2)/(2*sige_T(g,t))

                XX(:,2)=matmul(w_new,X)
                Y1=matmul(XX,beta_T(:,t))+alpha_T(g,t-1)+ep_2
                Y2=matmul(XX,beta_T(:,t))+alpha_1+ep_1
                S3=eye(NN)-lambda_T(t)*(W_new)
                S4=eye(NN)-lambda_T(t)*(W_new)
                CALL SGESV(NN,1,S3,NN,IPIV,Y1,NN,INFO)
                CALL SGESV(NN,1,S4,NN,IPIV,Y2,NN,INFO)

                q_1=0.5*gamma_T(9,t)*(dot_product(Y1,Y1)-dot_product(Y2,Y2))


                pp=q_1+like_Y1-like_Y2+((alpha_T(g,t-1)**2-alpha_1**2)/(2*A_0)) !


                CALL random_number(rand)
                IF (log(rand)<=pp)  THEN
                    alpha_T(g,t)=alpha_1
                    acc_3(g)=acc_3(g)+1.0
                ELSE
                    alpha_T(g,t)=alpha_T(g,t-1)
                END IF

                !END IF
                acc_rate3(g,t)=acc_3(g)/t
                !IF(acc_rate3(g,t)<=0.2) c_3(g)=c_3(g)/1.1
                !IF(acc_rate3(g,t)>=0.3) c_3(g)=c_3(g)*1.1

                DEALLOCATE(C,W,Wt,Y,X,XX,psi,S,W_old,W_new,Wt_old,Wt_new,S1,S2,Y1,Y2,Y1s,Y2s,pp_w,overage,psi_1,psi_2,S3,S4,ep_1,ep_2,IPIV)
            END DO
            !$omp end parallel

            call system_clock ( clock_stop, clock_rate, clock_max )
            t_round=t/20
            IF (t-t_round*20==0) THEN
                WRITE(*,*)   'T=', t
                WRITE(*,10) 'Time:', real ( clock_stop - clock_start ) / real ( clock_rate )
                WRITE(*,'(a6, 9f7.4)') 'GAMMA:', gamma_T(:,t)
                WRITE(*,10) 'LAMBDA:', lambda_T(t)
                WRITE(*,10) 'BETA:',   beta_T(:,t)
                WRITE(*,10) 'SIGE:',   sige_T(1,t), sige_T(11,t)
                WRITE(*,10) 'alpha:',  alpha_T(1,t), alpha_T(11,t), alpha_T(21,t), alpha_T(31,t)
                WRITE(*,10) 'acc_1:',  acc_rate1(t)
                WRITE(*,10) 'acc_2:',  acc_rate2(t)
                WRITE(*,10) 'acc_3:',  acc_rate3(1,t)
            END IF
            WRITE(1000,'(14f10.4)')  gamma_T(:,t)
            WRITE(2000,'(f10.4)')    lambda_T(t)
            WRITE(3000,'(30f10.4)')  beta_T(:,t)
            WRITE(4000,'(47f10.4)')  sige_T(:,t)
            WRITE(5000,'(47f10.4)')  alpha_T(:,t)

        END DO

        !***** Deinitialize *****
        errcode=vsldeletestream( stream )

    END DO

10  format(a6,5f10.4)
30  format(a6,6f7.4)
40  format(a6,8f8.4)
50  format(a6,5f8.4)
60  format(a6,f7.4)
70  format(30f9.4)


    end program estimation



